	PAGE
;Board Selection Subroutine
;Copyright 1988 by Mel Patrick
;Filename - BSWITCH/ASM
;
select	LD	HL,msg91	;BOARD LETTER OR ? for LIST
	CALL	hot		;and show it
	CP	'?'		;want a list of boards
	JR	NZ,selt0	;continue if not
	CALL	brdavl		;else show boards available
	JR	select		;and back to menu option
selt0	PUSH	AF		;save board selection
	CALL	bank1		;reselect users bank
	POP	AF		;get back letter selected
	CP	'A'		;must be from A - O
	JP	C,main		;go if <A
	CP	'P'+1		;else check high end
	JP	NC,main		;back if too high
	SUB	40H		;else make board 1-16
	LD	B,A		;else check to see if we are there
	LD	C,A		;move in case of selection
	LD	A,(board)	;get current board
	CP	B		;if already there ignore them
	JP	Z,main		;just back to menu
	LD	A,B		;get back board number
	CALL	brdchk1		;see if allowed on this board (SUB)
	JR	NZ,selok	;go if allowed NZ flag set
boor	JP	sorry		;else sorry and back to menu
selok	PUSH	BC		;C=code for new msg base
	LD	HL,msg92	;CHANGING TO ...
	CALL	out		;send it out
	POP	BC		;get back code in C
	PUSH	BC		;save it again
	LD	A,C		;get board digit 1-16
	LD	HL,brdnm	;point to list of names
	CALL	fndsy0		;point HL to board name
	LD	B,16		;then print it
	CALL	fmtnam		;show it on video
	CALL	cv71		;check for killed/saved
	JR	Z,selok0	;continue if no need to write back
	CALL	svbrd		;else save the current board
	CALL	ckroom		;count messages first
	CALL	calbrd		;redisplay board stats
	CALL	mailck		;and check for any of his mail now
selok0	CALL	cv75		;see if DL changed, SAVE if MD, yes
	POP	BC		;get back new board code
	LD	A,C		;else get board number wanted (1-16)
	CALL	cv72		;save it, find it, load it
	LD	A,(trkflg)	;see if mail tracking on
	OR	A		;Z=no, NZ=in progress
	JR	NZ,skpinc	;skip adding it
	LD	A,(board)	;see if public board
	CP	1		;if yes, don't increase callers
	JR	Z,skpinc	;go if yes
	CALL	addbrd		;add 1 to this board for calls
skpinc	CALL	cv3		;count users/dl/update/disply
	XOR	A		;remove kill/leave msg flags
	LD	(mkset),A	;when entering the new board
	LD	(akflag),A	;remove auto kill set bit too
	LD	A,(trkflg)	;see if track scan on
	OR	A		;Z=no, NZ=yes
	RET	NZ		;back if active
	JP	mlack		;else acknowledge of mail here
;
brdavl	LD	HL,msg93	;BOARDS AVAILABLE
	CALL	out		;send it out
	CALL	cret		;c/r
	CALL	upper		;switch to upper case
	CALL	bank1		;get users data info
	LD	C,'A'		;show board names and *
	LD	HL,brdnm	;point to names
	LD	A,1		;start with board 1
brdvlp	PUSH	AF		;save board number
	CALL	brdchk1		;see if allowed on this board
	JR	NZ,itsavl	;go if allowed
	LD	A,(track1)	;else see what kind of list we print
	BIT	5,A		;Z=print all, NZ=only accessable ones
	JR	NZ,notavl	;skip if only accessable ones
itsavl	PUSH	BC		;save character
	LD	A,'*'		;else we are allowed
	CALL	output		;send to video
	POP	BC		;the board letter
	CALL	mlmark		;and print board letter and name
notavl	POP	AF		;get back board number
	INC	C		;add 1 to letter
	LD	B,A		;move current to B for check
	LD	A,(maxbrd)	;get total allowed
	CP	B		;if =, then all done
	RET	Z		;go back if all done
	LD	DE,16		;else step to next
	ADD	HL,DE		;point HL to next one
	LD	A,B		;get back current board
	INC	A		;add 1 to it
	JR	brdvlp		;and loop til done
;
