;FASTPLUS duplicate routines.
;These are subroutines which can be referenced by other
;parts of the FastPlus code. The list was generated with
;the CODEVIEW/CMD program to show duplicates.
;Filename : CVSUB/ASM
;Copyright 1988 by Mel Patrick
;
cv3	CALL	quick		;update totals
	CALL	mvbrd		;copy ASCII name
	CALL	calbrd		;calculate and display
	RET			;and back
;
cv5	LD	HL,q1		;Name?
	CALL	out		;send it
	RET			;and go back
;
cv6	LD	BC,(maxusr)	;get maximum users
	LD	DE,78		;offset tween them
	RET			;and back with it
;
cv12	CALL	hot		;send to screen and wait
	CP	'Y'		;look for Y, set flag
	RET			;and go back
;
cv17	LD	A,(inexit)	;LOGON see if we want him off
	OR	A		;Z=no, NZ=yes
	JR	NZ,cv17a	;continue if booted
	CALL	cd		;else check for carrier
	RET	Z		;back if we got one
cv17a	POP	AF		;else remove RET address
	JP	lostcd		;and restart
;
cv18	LD	A,(len1)	;get input length
	OR	A		;test for anything there
	RET			;back with flags set
;
cv19	LD	DE,ustat+24	;where to store DATE
cv20	LD	BC,3		;move this many byte
	LDIR			;now
	RET			;and back
;
cv25	CALL	cvdate		;convert date
	LD	HL,dbuff	;point to date buffer
	RET			;go back
;
cv26	LD	DE,year		;point to year value
	EX	DE,HL		;swap dest <> source
	JR	cv20		;and then block move them
;
cv31	CALL	upper		;swing to upper case
	CALL	cd		;check carrier
	JR	NZ,chbort	;abort if lost
	CALL	chktim		;else check time
	JR	NZ,ctbort	;go if timed out
	RET			;else go back
chbort	POP	AF		;fix the stack
	JP	hbort		;and exit
ctbort	POP	AF		;fix the stack
	JP	tbort		;and exit
;
cv32	CALL	cd		;check for carrier
	RET	Z		;back if we have one
	JR	chbort		;else fix stack, abort
;
cv39a	LD	HL,msg25	;send out MSG#
	CALL	out		;send it
	RET			;and go back
;
cv41	LD	(val3),HL	;save # to look up
cv41a	CALL	fndusr		;find the user
	CALL	dspnam		;and show name
	RET			;and back
;
cv45	CALL	cret		;2 cr/s
	CALL	cret
	RET			;and go back
;
cv46	CALL	bank1		;select users bank
	CALL	b1ix73		;see if word wrap enabled
	CALL	NZ,wrpon	;enable if yes
	RET			;and then return
;
cv49	CALL	bank1		;select users bank
	CALL	b7ix74		;see if access
	RET	NZ		;back if yes
	POP	AF		;else nope
	JP	sorry		;and give bad news
;
cv53	CALL	bank3		;select msg bank
	CALL	gmay		;msg address to IY
	LD	A,(usrnum)	;get user number
	CP	(IY+8)		;check against header
	RET			;and go back
;
cv55	LD	HL,msg58	;FILENAME /EXT
	CALL	out		;send to remote
	LD	HL,dummy	;buffer to use
	LD	A,12		;allow input
	CALL	uinput		;get upper case input
	RET			;and then go back
;
cv56	CALL	bank2		;select download bank
	CALL	val1ix		;read value into IX
	RET			;and go back
;
cv59	CALL	cd		;check carrier
	RET	Z		;back if ok
	POP	AF		;else fix stack
	JP	eradow		;and erase download
;
cv60	CALL	openf		;open the file
	JR	NZ,cvfl		;go if file open error
	JR	C,nufile	;else go if its a new file
	CALL	bank1		;select users bank
	CALL	b7ix75		;see if master SYSOP online
	JR	Z,cvfl		;forget it, don't overwrite
	LD	HL,msg108	;else want to overwrite?
	CALL	hot		;show him
	AND	5FH		;convert to upper case
	CP	'Y'		;must be YES
	JR	NZ,cvfl		;skip if not
nufile	LD	HL,msg80	;else you got 60 seconds msg
	CALL	out		;send it out
	RET			;and go back
cvfl	POP	AF		;fix return on STACK
	JP	flerr2		;and enter error routine
;
cv62	CALL	closef		;close the file
	JP	NZ,ercon	;go if error in closing
	CALL	insrtk		;else insert K in filespec
	JP	sucess		;and continue
;
cv63	LD	HL,(xadd)	;get last address used
	LD	DE,128		;add for next block
	ADD	HL,DE
	LD	(xadd),HL	;save it for next time
	RET			;and go back
;
cv64	LD	B,3		;# of header bytes
	CALL	gosoh1		;get the start of header
	CALL	icrc16		;initialize CRC bytes
	LD	HL,(xadd)	;get address of data to send
	RET			;and continue
;
cv65	PUSH	BC		;used for reading from modem
	CALL	rdbyte		;read a byte
	POP	BC		;get back counter
	RET	Z		;back if character received
	CALL	cd		;else check for carrier
	JR	Z,cv65		;loop if we have one
	POP	AF		;else remove RETURN address
	POP	AF		;need TWO pop's?
	JP	erafil		;and abort the xfer
;
cv66	LD	HL,buffer	;point to buffer
	LD	(xadd),HL	;restore address to load at
	XOR	A		;then remove block counter
	LD	(block),A	;save it
	RET			;and continue
;
cv67	LD	DE,dummy	;point to buffer
	LD	BC,256		;bytes to move for write
	LDIR			;block move them
	CALL	write		;then write to disk
	RET			;back with any errors
;
cv69	CALL	nbta		;convert number to ASCII
	LD	HL,numbuf	;point to number
	LD	B,5		;bytes to show
	CALL	hotlin		;send to screen/remote
	RET	NC		;and back if not abort
	POP	AF		;else remove CALL
	JP	dofile		;and back to menu
;
cv71	CALL	akill		;remove any mail
	CALL	mailck		;check for more to him
	LD	A,(mkset)	;see if he left any
	LD	B,A		;move for checking
	LD	A,(akflag)	;see if any was killed
	OR	B		;set flags and go back
	RET			;now
;
cv72	LD	(board),A	;save board number
	CALL	fndsys		;find system in memory
	LD	(brdadd),HL	;save address of it
	CALL	lboard		;load this new board
	CALL	tstmdf		;see if more than one DL file
	CALL	NZ,lddown	;load multi DL if needed
	RET			;back with results
;
cv73	CALL	bank2		;select DL bank first
	CALL	gtupdr		;get drive number where its stored
	LD	(mdf+4),A	;insert upload drive# for DL file#
	LD	HL,mdf		;point to multi filespec
	CALL	tstmdf		;see if active multi files
	RET	NZ		;back if yes
	LD	HL,df		;else we use the single one
	RET			;and point to it and return
;
cv74	CALL	thayes		;test for HAYES type modem
	RET	Z		;back if not a HAYES modem
	LD	HL,hoff		;else ATZ it
	CALL	setmdm		;so we can work on it
	RET			;and then continue
;
cv75	CALL	tstmdf		;see if multi DL in effect
	JR	NZ,moddl	;skip check if YES
	LD	A,(track1)	;check BIT 2
	BIT	2,A		;Z=don't save on upload, NZ=YES!
	RET	Z		;start if no save wanted
moddl	CALL	dlupd		;see if DL cat changed
	CALL	NZ,svdown	;save if changed
	RET			;back all done
;
