;Main body of FastPlus BBS program
;Copyright 1988 by Mel Patrick
;Filename - FASTPLUS/ASM

	GET	MASTER/SVC	;all the svc codes used
	ORG	2600h		;for now, maybe lower later (2600H)
;
buff2	EQU	420H		;uses the TRSDOS INPUT buffer
stx	EQU	2		;STX used for ymodem
;
	GET	FPDATA/ASM	;configuration DATA
;
bbs	CALL	cls		;erase screen completely
	LD	HL,mkset	;zero mkset/akflag/route/trkflg
	LD	BC,5
	CALL	erase		;for starting
	CALL	draw		;show _ line on video
rebbs	LD	SP,037EH	;reset stack pointer use DOS pointer
	LD	HL,tusr
	CALL	erausr		;erase 77 user bytes
	CALL	clrtyp		;clear out type ahead buffer
	LD	HL,(logger)	;total user since sysop
	LD	DE,msg1+1	;where to format number
	CALL	bindec		;convert to decimal
	CALL	upnumb		;redo update rate
	LD	A,(ctrl)	;turn on bell for starters
	RES	2,A		;enable xlate table
	SET	5,A		;turn off if not wanted later
	LD	(ctrl),A	;save it
	CALL	t2scr		;move title to screen
	CALL	cls1		;clear bottom of video screen
	CALL	ldinit		;load USERS/DOWNLOADS/PUBLIC if ok
	LD	A,(online)	;get control byte from memory
	AND	32		;mask out for BELL
	SET	3,A		;turn on CR+LF
	LD	(online),A	;save it again
	LD	HL,ctrl2	;reset user type flags
	RES	6,(HL)		;not new
	RES	7,(HL)		;not reg
	CALL	fndsys		;find system board
	LD	(brdadd),HL	;save it
	CALL	cv3		;update totals/move ascii/display
	CALL	upper		;switch to upper case
	LD	HL,ustat+28
	LD	B,7		;bytes to clear each time
clrtrk	LD	(HL),'.'
	INC	HL
	DJNZ	clrtrk
	LD	HL,'..'		;pair of periods
	LD	(ustat+64),HL	;save it
	LD	(ustat+67),HL	;to remove last time caller was on
	LD	A,' '		;remove CD id
	LD	(ustat),A	;for new caller
	LD	(ustat+78),A	;and remove the c/r
	CALL	scrset		;set up for screen blanking
cdrep	CALL	scron0		;WAITING msg to video
resv	LD	A,2		;allow 2 trys before changing baud
svnwt	LD	(mask),A	;save it
waitlp	CALL	sblank		;test for screen blanking
	XOR	A		;always cancel timeouts
	LD	(timeout),A	;save it
	LD	HL,online	;point to status bits
	RES	4,(HL)		;reset incase of drop without connect
	CALL	kbd		;scan keyboard
	JR	NZ,trem		;go if nothing
	PUSH	AF		;save character
	CALL	scron		;enable screen
	POP	AF		;get back char and process
	CP	81H		;F1 from keyboard
	JP	Z,svdata	;go save data if yes
	CP	82H		;turn off the chat bell
	JP	Z,chatog
	CP	83H		;else we want a local connection
	JP	Z,doloc		;go if local from keyboard
	CP	1DH		;shift enter?
	JP	Z,conect	;connect
	CP	13		;see if c/r generated
	CALL	Z,t2scr		;remove the users names
	CP	' '		;turn on last five callers
	CALL	Z,dspuse	;users to display
	CP	0C2H		;SYSOP CLR B (toggle baud)
	JR	Z,swb		;go if yes
	CP	91H		;SHIFT F1, save and EXIT
	JP	Z,sax		;go if yes
	JR	waitlp		;then back to menu
trem	CALL	carrier		;check for carrier
	JR	Z,waitlp	;NZ=cd process remote, Z=process LOCAL
	CALL	scron		;enable screen now!
	CALL	rdbyte		;else check the RS232
	JR	NZ,waitlp	;back if nothing received
	LD	C,A		;save character
	CALL	thayes		;see if HAYES modem
	JR	Z,nohayes	;go if not
	LD	A,C		;else get back character
	CP	'1'		;see if 300 wanted
	JR	Z,go3		;go if yes
	CP	'5'		;else want 1200 baud
	JR	Z,go1200	;go if yes
	JR	trem		;else must be one of these
go3	LD	DE,8000		;do a LOT of scans
go3lp	CALL	carrier		;check for a carrier
	JP	Z,waitlp	;back if nothing to wait for
	CALL	rdbyte		;get character from RS232
	JR	NZ,go33		;continue if no character recd
	CP	0DH		;else we look for C/R or '0'
	JR	Z,want3		;if C/R we want 300 baud
	CP	'0'		;if its 10 c/r its 2400
	JR	Z,want24	;go if 2400 wanted
go33	DEC	DE
	LD	A,D
	OR	E		;Z=all done
	JR	NZ,go3lp	;loop til L=0
	JP	waitlp		;and just forget it
want24	CALL	do2400		;set for 2400 baud
	JR	contp		;and continue
want3	CALL	do300		;set 300 baud
	JR	contp		;and continue
go1200	CALL	do1200		;else set for 1200 baud
contp	CALL	delay2		;wait for UART to switch
	JR	conect		;and continue
nohayes	LD	A,C		;get back character
	CP	13		;got a c/r
	JR	Z,conect	;go if yes, got baud rate right
	LD	A,(mask)	;else get value for switch
	DEC	A		;minus 1
	OR	A		;if not zero then try again
	JP	NZ,svnwt	;so save it and wait
swb	CALL	baudsw		;so change baud rate (if possible)
	JP	resv		;and try for 2 again
lostcd	CALL	discon		;restore to baud default
	CALL	clrtyp		;empty buffer
	JP	bbs		;and restart program
doloc	SET	0,(HL)		;set bit for local from keyboard
	CALL	cv74		;disconnect HAYES if thats online
	JR	conec0		;and continue
conect	RES	6,(HL)		;we don't know who user is yet
	RES	0,(HL)		;show not from keyboard local
	CALL	wait2		;delay to stabilize
	CALL	clrtyp		;empty type ahead buffer to start
conec0	LD	HL,0		;reset time online
	LD	(tsec),HL	;save it
;
	GET	LOGON/ASM	;signon module
;
	GET	MAILACK/ASM	;inform about mail
;
	CALL	bulsub		;show bulletins (if possible)
	JR	C,skpres	;skip prompt on ctrl C ret
	CALL	resume		;msg8 pause
skpres	NOP			;someplace to make it go
	GET	MENU1/ASM	;main menu selections
	GET	MENU2/ASM	;second menu
	GET	MENU3/ASM	;up down menu
	GET	MENU4/ASM	;sysedit menu
	GET	MENU5/ASM	;user list otpions
	GET	USRLST/ASM	;user list options
	GET	CHAT/ASM	;chat subroutine
	GET	MSGENT/ASM	;MSG entry module, also menu select
	GET	MSGENT1/ASM	;second part of routine
	GET	UPDOWN/ASM	;upload/download module
	GET	UPDOWN1/ASM	;second half (XMODEM)
	GET	UPDNCAT/ASM	;catalog portion of updown
	GET	SYSEDIT/ASM	;EDIT MODULE
	GET	USREDIT/ASM	;user edit module
	GET	TERMIN/ASM	;terminate module
	GET	INPUT/ASM	;main line input module
	GET	BSWITCH/ASM	;board switching routine
	GET	AUTOKILL/ASM	;auto msg kill subroutine
	GET	MDMCTRL/ASM	;modem init/disconnect routines
	GET	SUB/ASM		;subroutines
	GET	CVSUB/ASM	;compacted subroutines
	GET	FPHELP/ASM	;HELP module
	GET	FPBLANK/ASM	;screen blanking module
;
	PAGE			;**** New Pages
;
bullsb	CALL	showbl		;show bulletins
	CALL	resume		;display a message and wait
	JP	main		;back to main menu
;
cd	CALL	ckola		;Z=remote, NZ=local
	JR	NZ,cdok		;sysop in control (local)
	BIT	4,A		;0=cd 1=dropped
	JR	Z,cdok		;go if still cd
	BIT	6,A		;see if we know the user
	JR	Z,cdun		;go if unknown
	CALL	bank1		;else select users bank
	SET	0,(IX+73)	;turn on drop flag
	INC	(IX+34)		;and add to the drop total
	LD	A,'*'		;show dropped carrier
	LD	(ustat),A	;insert in user record
	CALL	u2scr		;move to screen
cdun	JP	nonum		;set NZ flag, ret
cdok	CP	A		;set the zero flag
	RET			;and then go back
;
cls1	LD	HL,0400H	;set r/c
	CALL	setrc		;set r/c
	LD	C,31		;erase to bottom of display
	CALL	vidout		;send to video
curon	LD	A,14		;enable cursor
curctl	JP	vido		;send to us (RET IN VIDOUT)
curoff	LD	A,15		;cursor disable
	JR	curctl		;do it
;
cls	LD	A,@cls
	RST	svc
	RET			;clear video and ret
;
setrc	PUSH	BC		;save reg
	LD	B,3		;set to R/C on screen
	CALL	toscr0		;@VDCTL codes
	POP	BC		;restore reg
	RET			;and go back
;
vido	LD	C,A		;move for display
	CP	8		;backspace?
	JR	Z,vidout
	CP	9		;tab?
	JR	Z,vidout
	CP	0AH		;linefeed?
	JR	Z,vidout
	CP	13		;ENTER
	JR	Z,vidout
	CP	14		;cursor on
	JR	Z,vidout
	CP	15		;cursor off
	JR	Z,vidout
	CP	1DH		;back to star of line?
	JR	Z,vidout
	CP	1EH		;erase to end of line
	JR	Z,vidout
	CP	1FH		;end to end of display
	JR	Z,vidout
	CP	' '		;else check for control code
	RET	C		;back if too low to print
vidout	LD	DE,(vdcb)	;get video device control block
	CALL	put		;write to video
	RET			;and back to caller
;
clrtyp	DI			;turn off interupts
	LD	A,(incir)	;set in/out to the same
	LD	(outcir),A	;so we have nothing
	EI			;enable interupts again
	RET			;and go back
;
bulsub	LD	HL,bulflg	;get bulletins flags
	LD	A,(board)	;see which board we are in
	CP	9		;if less than 9, lower ones
	JR	C,bul1		;go if first (L) wanted
	SUB	8		;else we want the second
	LD	B,A		;move for pattern type
	INC	HL		;point to MSB boards
	LD	A,(HL)		;get the pattern
	JR	bul2		;and continue
bul1	LD	B,A		;get LSB board patterns
	LD	A,(HL)		;get LSB patterns
bul2	PUSH	BC		;save counter
bul3	RRA			;rotate through to carry position
	DJNZ	bul3		;see if bulls wanted
	POP	BC		;restore count in case
	RET	C		;back if already read
	SCF			;else set the carry flag
bul4	RLA			;shift the new value back in
	DJNZ	bul4		;loop til back in position
	LD	(HL),A		;save result for next time
showbl	CALL	cret		;do a c/r
	LD	HL,msg5+4	;bulletins message
	CALL	hotret		;send it out
	CALL	cret		;and do a c/r
	LD	HL,bulrec	;point to filespec
	JP	dbfile		;and open and print it
;
nobull	LD	HL,msg5		;no bull msg
	CALL	out		;send it out
	RET			;and go back
;
out	CALL	vidspl		;special character codes
	LD	A,(HL)		;get a byte
	CP	3		;end of message
	RET	Z		;back if yes
	CALL	output		;else send it out somewhere
	INC	HL		;point to next
	JR	out		;loop til 3 found
;
upper	PUSH	HL		;save reg
	LD	HL,ctrl		;point to control
	SET	7,(HL)		;permit upper case only
	POP	HL		;get back reg
	PUSH	IY
	LD	IY,(flags)	;get flag table pointer
	SET	5,(IY+10)	;allow only upper case
	POP	IY
	RET			;and go back
;
lower	PUSH	HL
	LD	HL,ctrl
	RES	7,(HL)
	POP	HL
	PUSH	IY
	LD	IY,(flags)
	RES	5,(IY+10)	;allow keyboard lower
	POP	IY
	RET			;get byte, return to allow both cases
;
vidspl	LD	A,(HL)		;get the byte first
	CP	9		;want tab?
	JR	Z,wntab		;go if yes
	CP	4		;change address (no resume)
	JR	Z,newadd	;go if yes
	CP	5		;change address (resume possible)
	JR	Z,swapad	;go if yes
	CP	6		;else resume address (use with 5)
	JR	Z,restad	;go if yes
	RET			;else just return
wntab	INC	HL		;point to length of tab
	PUSH	BC		;save reg
	LD	B,(HL)		;get length to use
tblp	LD	A,' '		;use space for tab
	CALL	output		;send to both
	DJNZ	tblp		;loop til done
	POP	BC		;restore reg
	INC	HL		;point to next character
	RET			;and go back now
newadd	INC	HL		;point to LSB address
	LD	E,(HL)		;get LSB
	INC	HL
	LD	D,(HL)		;get MSB
nwadd	EX	DE,HL		;move HL to new address
	JR	restt		;check for continues before RET
swapad	INC	HL		;point to LSB
	LD	E,(HL)		;get address
	INC	HL
	LD	D,(HL)		;get address
	INC	HL		;point to where to resume
	LD	(resadd),HL	;save for resume
	JR	nwadd		;and continue
restad	LD	HL,(resadd)	;where to resume at
restt	LD	A,(HL)		;check for resume 4,5
	CP	4
	JR	Z,vidspl	;repeat if yes
	CP	5		;else swap an address
	JR	Z,vidspl	;repeat if yes
	RET			;and continue processing
;
fndspt	LD	A,(HL)		;look for a blank entry point
	OR	A		;ses if found
	RET	Z		;back if yes
	DEC	BC
	LD	A,B
	OR	C
	JP	Z,nonum		;go if no spots
	ADD	HL,DE		;else point to next
	JR	fndspt		;loop til found or none
;
date	LD	HL,dbuff	;point to date buffer
	PUSH	HL		;save it
	CALL	thdate		;@date
	LD	A,(track1)	;check BIT 1
	BIT	1,A		;Z=user00, NZ=month
	JR	Z,date0		;skip if not by month
	LD	HL,(dbuff)	;read MM in HL
	LD	(usrec+4),HL	;and insert for LOG
date0	POP	HL		;then restore it
	LD	A,13		;insert a terminator
	LD	(dbuff+2),A
	LD	(dbuff+5),A
	LD	(dbuff+8),A	;insert for conversion
	LD	DE,month	;point to month storage
	CALL	decbin		;convert to ASCII
	LD	A,C		;get month
	LD	(DE),A		;save it in MONTH
	INC	DE		;point to DAY
	CALL	dtsub		;convert decimal to binary
	LD	A,C
	LD	(DE),A		;save the day
	CALL	dtsub		;convert decimal to binary
	DEC	DE		;back up to YEAR (first)
	DEC	DE		;have to get there
	LD	A,C
	LD	(DE),A		;save year
	LD	A,'/'		;put the / back in
	LD	(dbuff+2),A
	LD	(dbuff+5),A
	LD	A,3		;remove last
	LD	(dbuff+8),A	;and restore to original
	RET
;
cvdate	PUSH	HL		;move date start to IX
	POP	IX		;now
	PUSH	IX		;save for return
	CALL	cvdsub		;convert YYMMDD to ASCII
	LD	DE,dbuff+6	;point to date buffer (YY)
	CALL	cvds0		;move to buffer and do MM
	LD	DE,dbuff
	CALL	cvds0		;move to buffer, do DD to ascii
	LD	DE,dbuff+3
	CALL	copyd		;move to date buffer
	POP	IX		;get back INDEX in case
	RET			;and go back
;
cvds0	CALL	copyd		;move to buffer
cvdsub	LD	L,(IX)		;get YY/MM/DD (in binary)
	INC	IX		;point to next
	LD	H,0		;remove MSB
	CALL	donum		;convert to ASCII
	RET			;and back to main body
;
copyd	LD	HL,numbuf+3	;point to buffer
copyd0	LD	A,(HL)		;get a byte
	CP	3		;eol?
	RET	Z		;back if yes
	CP	' '		;if not space, then number
	JR	NZ,copyd1	;go if not space
	LD	A,'0'		;else replace with zero
copyd1	LD	(DE),A		;insert in buffer
	INC	HL
	INC	DE		;step through
	JR	copyd0		;loop til 3 hit
;
cvtime	LD	HL,(tsec)	;l=seconds, h=hours
	PUSH	HL		;save time and seconds
	LD	H,0		;remove MSB
	CALL	donum
	LD	DE,tbuff+6	;store seconds
	CALL	copyd		;move data
	POP	HL		;get back mm/ss
	LD	L,H
	LD	H,0
	CALL	donum
	LD	DE,tbuff+3
	CALL	copyd		;move to buffer
	LD	HL,tbuff+3	;where to start move
	LD	DE,ustat+64
	LD	BC,5
	LDIR			;and move to buffer
	CALL	ckola		;check for dropped cd
	BIT	4,A		;Z=ok, NZ=dropped
	RET	NZ		;back if he dropped it
	JP	u2scr		;and copy user to screen, (RET)
;
addbrd	CALL	gba		;get board address
	CALL	rdix01		;read ix into HL
	INC	HL		;add 1 to board list
	CALL	svix01		;save HL back into IX
	RET			;then go back
;
addtot	LD	IX,sys		;point to master system info
	LD	L,(IX+14)	;get total master count
	LD	H,(IX+15)	;"	"
	INC	HL		;add 1 for total callers
	LD	(IX+14),L	;and save it on 1 location only
	LD	(IX+15),H	;"	"
	RET			;and go back
;
chktim	CALL	ckola		;Z=remote, NZ=local keyboard
	JR	NZ,chktok	;no limit for local control
	LD	A,(tmflag)	;see if master limit imposed
	OR	A		;0=no, 1=yes
	JR	NZ,chkt		;go if master time limit on
	LD	B,4		;find which bank is being used
	CALL	setbnk		;set BANK
	LD	C,A		;move for redoing
	LD	B,0		;set for returning to original bank
	PUSH	BC		;save it
	CALL	bank1		;select users bank and address
	LD	A,(IX+73)	;check for restricted time
	POP	BC		;now switch back to original bank
	PUSH	AF		;save flags
	CALL	setbnk		;setup a BANK
	POP	AF		;and get back flags
	BIT	6,A		;test bit 6 on off
	RET	Z		;back if bit off
chkt	LD	A,(tmin)	;get time on system so far
	LD	B,A		;move for checking
	LD	A,(tmax)	;get max allowed
	CP	B		;check for time limit
	JR	NC,chktok	;go if still under time limit
	JP	nonum		;set NZ flag, ret
chktok	CP	A		;else if ok, set Z flag
	RET			;and go back
;
resume	LD	HL,msg8		;press to continue
	CALL	hot		;send to remote
	RET			;and go back
;
draw	LD	HL,buffer	;point to empty buffer
	PUSH	HL		;save for later
	LD	B,81		;bytes to fill
drawlp	LD	(HL),'_'	;insert characters
	INC	HL
	DJNZ	drawlp		;for whole line
	LD	H,3		;then move to video display
	POP	DE		;DE points to string to move
	JR	toscr		;and block move it to video
t2scr	LD	H,0		;row to use
	LD	DE,title	;title line
	JR	toscr		;buffer to video screen
b2scr	LD	H,2		;row to show it at
	LD	DE,bstat	;board stats
	JR	toscr		;and do it
u2scr	LD	H,1		;row to show it at
	LD	DE,ustat	;buffer to use
toscr	LD	BC,900H		;buffer to screen
toscr0	LD	A,@vdctl
	RST	svc
	RET			;back now
;
wrpon	LD	A,1		;set word wrap on
wrpon0	LD	(wflag),A	;save it
	RET			;and go back
wrpoff	XOR	A		;remove word wrap flag
	JR	wrpon0		;save and return
;
disply	CALL	vidspl		;check for special codes
	LD	A,(HL)		;get a byte
	CP	3		;end of line?
	RET	Z		;back if yes
	CP	2		;want 2 c/rs?
	JR	NZ,displ0	;skip if not
	LD	A,13
	PUSH	AF
	CALL	vido
	POP	AF		;get back second code
displ0	CALL	vido		;send to video
	INC	HL		;point to next char
	JR	disply		;loop til eol
;
sorry	LD	HL,err6		;insufficient access level
	CALL	hot		;send it out
	JP	main		;and back to menu
;
brdpat	LD	A,(board)	;get board in effect to gen pattern
	CP	9		;see if greater than board 8
	JR	C,nosubb	;if yes, don't subtract for second
	SUB	8		;else make it digit 1-9
nosubb	LD	B,A		;stuff in reg
	XOR	A		;zero out A reg
	SCF			;set bit in the carry flag
brdrt	RLA			;and rotate into position to use
	DJNZ	brdrt		;do it
	LD	(bitpat),A	;and save board pattern
	RET			;back now
;
rechr	IN	A,(0EAH)	;get byte from status port
	AND	80H		;check the rec bit
	RET	Z		;back if no character here
	IN	A,(0EBH)	;else read in the byte
	LD	C,A		;move for check in buffer
	LD	A,(incir)	;get storage position
	AND	3FH		;mask for 0-63 (64 char buffer)
	LD	HL,stbuff	;else point to start of buffer
	LD	E,A		;move new length to DE
	LD	D,0
	ADD	HL,DE		;HL now points to new position to store
	LD	(HL),C		;insert in buffer
	LD	HL,incir	;advance storage position now
	INC	(HL)		;for next character
	RET			;and go back
;
rdbyte	LD	A,(incir)	;get position of incoming
	PUSH	BC		;save reg
	LD	B,A		;move for checking
	LD	A,(outcir)	;get position of retrieving
	CP	B		;see if same position
	POP	BC		;restore it now
	JP	Z,nonum		;if yes, nothing received
	AND	3FH		;else mask for proper position
	PUSH	HL		;save the regs
	PUSH	DE
	LD	HL,stbuff	;point to start of input buffer
	LD	E,A		;move for getting char
	LD	D,0
	ADD	HL,DE		;point HL to character 0-63 position
	POP	DE		;restore DE reg
	LD	A,(HL)		;read it from the position
	LD	HL,outcir	;then get pointer
	INC	(HL)		;add 1 to position
	LD	HL,ctrl		;point to control byte
	BIT	2,(HL)		;0=Xlate ON 1=Xlate OFF
	JR	NZ,xpro		;recieve all if off
	PUSH	BC		;save reg first
	LD	C,A		;save character
	LD	B,0		;remove MSB for adding in case
	AND	7FH		;mask out HIGH bits
	CP	7FH		;see if DELETE key
	JR	NZ,ndk		;go if NOT DELETE KEY
	LD	A,8		;else its a backspace
	JR	skptab		;and continue
ndk	CP	' '		;see if CONTROL value
	JR	NC,skptab	;go if we can use it (ASCII)
	LD	HL,table	;else point to table
	ADD	HL,BC		;find the byte from table
	LD	A,(HL)		;read byte out
skptab	POP	BC		;get back reg first
	POP	HL		;restore HL register
	AND	7fh		;mask out that top bit
	OR	A		;if 0, then nothing received
	JP	Z,nonum		;so skip if non valid code
	PUSH	BC		;save it again
	LD	C,A		;now check for UPPER/lower case
	LD	A,(ctrl)	;get control byte
	BIT	7,A		;0=both 1=UPPER only
	JR	Z,both		;go if both allowed
	LD	A,C		;get back char rec
	CP	61H		;check for lower case
	JR	C,allup		;skip if already upper case
	AND	5fh		;else make it upper
allup	LD	C,A		;move back for reloading
both	LD	A,C		;get back character
	POP	BC		;restore BC before ret
both0	CP	A		;set the zero flag
	RET			;and go back with character
;
xpro	POP	HL		;restore the reg
	JR	both0		;and exit back with character
;
output	LD	C,A		;save character
	LD	A,(online)	;check for carrier on line
	BIT	2,A		;0=no carrier 1=cd detect
	JR	Z,outvid	;send to video only if no CD
	LD	A,(vidpas)	;0=normal 1=bypass output
	OR	A
	JR	NZ,outvid	;bypass if required
	LD	A,C		;else we send to RS232
	CP	2		;want TWO C/Rs?
	JP	Z,crsub		;go if yes (SUB/ASM)
	CP	7		;else want a bell?
	JR	Z,spcl3		;check if they want it
	CP	8		;want a backspace?
	JR	Z,spcl1		;go if special routine
	CP	9		;tab char?
	JR	Z,spcl4		;special routine if yes
	CP	13		;else CR+LF?
	JR	Z,spcl2		;go if special routine
bck	CALL	sbyte		;send to remote
	JR	out1		;and continue with our video
spcl1	LD	A,(online)	;check for normal bck or vid
	BIT	1,A		;0=normal 1=video type
	LD	A,8		;load up a default in case
	JR	Z,bck		;if normal just ret
	CALL	sbyte		;else send backspace
	LD	A,' '		;then a space
	CALL	sbyte
	LD	A,8		;then a backspace again
	JR	bck		;and reenter routine
spcl2	LD	A,(online)	;get cr+lf status
	BIT	3,A		;0=cr only
	JR	Z,spcl2a	;back in if only cr wanted
	LD	A,10		;else we need both
	CALL	sbyte
spcl2a	LD	A,13		;now a c/r
	JR	bck		;so go do it
spcl3	LD	A,(ctrl)	;get control word fo bell bit
	BIT	5,A		;0-bell off, 1-bell on
	RET	Z		;back if off
	LD	A,7		;bell value
	CALL	sbyte		;send to remote
	RET			;and go back without ringing
spcl4	PUSH	BC		;save counter
	LD	A,(tablen)	;get tab length to use
	LD	B,A		;move to loop counter
sp4lp	LD	A,' '		;use a space
	CALL	vido		;send to our video
	CALL	ckola		;Z=remote, NZ=local keyboard
	JR	NZ,spcl4a	;skip rs232 if local
	LD	A,(vidpas)	;remote on line
	OR	A
	JR	NZ,spcl4a	;skip if yes
	LD	A,' '		;else send out a space too
	CALL	sbyte		;to rs232
spcl4a	DJNZ	sp4lp		;continue til done
	POP	BC		;restore reg
	RET			;and go back now
;
outvid	LD	A,C		;get back character video only
	CP	9		;want a tab?
	JR	Z,spcl4		;do it if yes, use RET there
	CP	2		;want TWO c/rs
	JP	Z,crsub		;do 2 c/rs (SUB/ASM)
	PUSH	BC		;save B counter
	LD	BC,(rate)	;get rate of printing
	CALL	delpaw		;@pause
	POP	BC		;restore B counter
	LD	A,C		;get back video character
out1	JP	vido		;print, use RET in vido to get back
;
ready	IN	A,(0eah)	;look at status
	AND	40h		;test modem ready
	RET	NZ		;back if ready
	JR	ready		;else loop til ready
;
sbyte	PUSH	AF		;save character
	CALL	ready		;wait til ready
	IF	koss		;slow down routine for kossawan
	PUSH	BC		;save regs
	LD	BC,(rate)	;get video update rate
	CALL	delpaw		;do @pause
	POP	BC		;get back pointer
	ENIF			;end of slow down routine
	POP	AF		;get back character
	OUT	(0ebh),A	;send it out
	RET			;and go back
;
chatog	LD	HL,online	;point to variable
	LD	A,32		;mask value
	XOR	(HL)
	LD	(HL),A		;store new result
	BIT	5,A		;test it
	JR	Z,togon		;go if chat bell ON
	LD	HL,msg2		;NZ=BELL OFF
toggle	PUSH	HL		;save it
	LD	HL,msg4		;CHAT BELL :
	CALL	disply		;show msg
	POP	HL		;and show result
	CALL	disply		;now
	CALL	cret		;do a c/r
cbdis0	JP	waitlp		;and back to waiting
togon	LD	HL,msg3		;ON msg
	JR	toggle		;and continue
;
svdata	LD	HL,msg81	;saving SYSTEM Data
	CALL	out
	CALL	svsys		;go do it
	LD	HL,msg82	;SAVING USER data
	CALL	out
	CALL	svuser		;do it
	LD	HL,msg83
	CALL	out
	CALL	svdown		;save download info
	LD	HL,msg84	;SAVING Message data
	CALL	out
	CALL	svbrd		;and save it
expat	CALL	reupdt		;reset auto update rate
	LD	HL,msg1		;and ready for call again
	CALL	out		;show it on screen
	JR	cbdis0		;and back to menu
;
ldinit	LD	HL,ctrl		;point to control word
	BIT	0,(HL)		;0=loadem all 1=skip it
	RET	NZ		;back if not wanted to load
	SET	0,(HL)		;else only load once
	LD	A,13		;do a c/r
	CALL	output
	LD	A,'P'		;start with P for PLUS
	CALL	output
	CALL	ldsys		;go load system info
	LD	A,'L'
	CALL	output
	CALL	lduser		;load users data
	LD	A,'U'
	CALL	output
	CALL	lddown		;load download data
	LD	A,'S'
	CALL	output
;
lboard	CALL	bank3		;use bank 3 for messages
	LD	A,128		;blocks
	LD	(try),A		;get that many
	CALL	fndbrd		;find filespec to use
	PUSH	HL		;save file pointer
	CALL	openfl		;and open only
	POP	HL		;point back to filename
	JP	NZ,na		;go if board not available
	JP	ldu		;and load the board
;
ldsys	LD	HL,sf
	CALL	openfl
	JR	NZ,nosys	;go if no sys file available
	LD	HL,sys		;else point to data
	LD	B,0		;bytes to read in
rdsys	CALL	fget		;read from file (DE=FBUFF)
	JP	NZ,dskerr	;go if disk error
	LD	(HL),A		;insert in routine
	INC	HL
	DJNZ	rdsys
	RET
;
nosys	LD	HL,sys		;point to data in ram
	LD	BC,255		;bytes to erase -1
	CALL	erase
	JR	svsys0		;and continue
;
svsys	CALL	quick		;use a sub to update counts
svsys0	LD	HL,sf
	CALL	crfile
	LD	HL,sys
	LD	B,0
wrsys	CALL	fcput		;write to file (DE=FBUFF) C=char
	JP	NZ,dskerr	;go if error during write
	INC	HL
	DJNZ	wrsys		;loop for count to file
	JP	closef		;use RET in subroutine
;
lddown	LD	A,128		;blocks to load
	LD	(try),A		;save it
	CALL	cv73		;insert drive#, filespecs
	JR	openld		;open file, try to load it
;
svuser	CALL	countu		;count the users first
	CALL	bank1
	LD	HL,uf
	LD	A,(bankld)	;get total blocks
svu0	LD	(try),A		;save in routine
	JP	wrbank		;and write bank to disk
;
svdown	CALL	countd		;count downloads before saving
	XOR	A		;remove SAVE flag
	LD	(upflag),A	;in case of upload
	CALL	cv73		;insert drives, filenames
svd	LD	A,128		;blocks to load
	JR	svu0
;
svbrd	CALL	ckroom		;count messages before save
	CALL	bank3
	CALL	fndbrd		;find the board filename
	JR	svd		;and write the bank to disk
;
lduser	CALL	bank1		;set memory bank 1 for users
	LD	A,(bankld)	;get total 256 byte blocks to load
	LD	(try),A		;save here for loading
	LD	HL,uf		;users filespec
openld	PUSH	HL		;save file pointer
	CALL	openfl		;open only
	POP	HL		;get back pointer
	JR	NZ,na		;go if not available
ldu	LD	A,@read		;get code for read
bankio	LD	(iocode),A	;save for reading writing
bkout	LD	A,(try)		;get total blocks to write out
	LD	B,A		;move to B
	LD	HL,8000h	;start for reading or writing
rdblp	LD	(temp),HL	;save in variable
	CALL	mvout		;memory to buffer?
	LD	DE,fbuff	;point to FCB
	LD	A,(iocode)	;read or write in same routine
	RST	svc
	JP	NZ,dskerr	;go if we have a disk error
	CALL	mvin		;buffer to memory?
	LD	HL,(temp)	;get last address used
	INC	H		;add 256 to it
	DJNZ	rdblp		;and insert back in for next read
	LD	A,(iocode)	;check for read/write
	CP	@read		;if read don't bother closing the file
	RET	Z		;else if its write then close it
	CALL	closef		;and close the file
	JP	NZ,dskerr	;go if disk error
	RET			;and go back
;
mvin	LD	A,(iocode)	;test for a read
	CP	@write		;if write to disk forget it
	RET	Z		;back if write routine enabled
	SCF			;else set carry and do routine
	JR	m2b		;let routine go proper direction
mvout	LD	A,(iocode)	;get code we are using
	CP	@read		;read from disk?
	RET	Z		;back if read wanted
	OR	A		;clear the carry
m2b	LD	HL,(temp)	;get point in RAM
	LD	DE,dummy	;get buffer we are using
	PUSH	BC		;save counter reg
	JR	C,b2m		;go if moving buffer to ram
movit	LD	BC,256		;bytes to move
	LDIR			;copy them to buffer
	POP	BC		;fix stack
	RET			;and go back
b2m	EX	DE,HL		;swap DE=ram, HL=buf
	JR	movit		;and move it
;
na	PUSH	HL		;save file pointer
	LD	BC,7FFFH	;bytes to erase
	LD	A,(try)		;see if full or partial
	CP	128		;Z=full, NZ=partial
	JR	Z,fulera	;go if full erase
	LD	BC,(maxram)	;else its only a partial
fulera	LD	HL,8000H	;start of bank
	CALL	erase		;erase all the data
	CALL	clrbrd		;empty all board data
	POP	HL		;get back file pointer
;
wrbank	CALL	crfile		;create the file
	LD	A,@write	;use the write code
	JR	bankio		;and save the data
;
crfile	CALL	crfcb		;create an FCB
	CALL	addext		;add extension
	CALL	flinit		;and INIT a file (NEW)
	JP	NZ,dskerr	;go if error in create
	RET
;
openfl	CALL	crfcb		;create a FCB
	CALL	addext		;add extension
	CALL	flopen		;and OPEN a file
	RET
;
erase	PUSH	HL
	POP	DE		;used for zeroing memory locations
	INC	DE
	LD	(HL),0
	LDIR
	RET			;back after all zero
;
fndbrd	LD	HL,othdrv	;point to drive table
	CALL	gtbrdr		;get board drive # in A
	LD	(othbrd+7),A	;insert new drive #
	LD	A,(board)	;get board letter
	PUSH	AF		;save board number
	ADD	A,40H		;make A=ASCII board letter
	LD	(othbrd+5),A	;insert in filespec
	LD	(bstat+4),A	;insert in board status line
	POP	AF		;get back board number now
	DEC	A		;make it 0-15
	ADD	A,A		;*2
	LD	HL,scsize	;point to start of info
	LD	E,A
	LD	D,0
	ADD	HL,DE		;HL=information
	LD	A,(HL)		;get line length
	LD	(linel),A	;move to new location
	PUSH	AF		;save for calcs
	INC	HL		;point to number lines per msg
	LD	A,(HL)
	LD	C,A		;move for calcs
	LD	(msglin),A	;save it
	LD	H,0		;set for finding msg size
	POP	AF		;get back LINEL
	LD	L,A		;move for calcs
	CALL	mul16		;multiply by 16
	LD	H,L		;then shift to HL
	LD	L,A		;and save the length
	LD	DE,38		;then add header length
	ADD	HL,DE		;HL=total possible length +1
	LD	(msgsz),HL	;in memory for CKROOM sub
	LD	HL,othbrd	;point HL to filespec
	RET			;and go back now
;
mvbrd	LD	HL,brdnm	;point to ASCII list of board names
	LD	A,(board)	;get current board
	CP	1		;at first one
	JR	Z,mvbrd0	;go if yes
	DEC	A		;minus 1
	LD	DE,16		;else offset tween names
	CALL	brdstp		;go point HL to ASCII name
mvbrd0	PUSH	HL		;save pointer
	LD	DE,bstat+7	;where to move it to
	LD	BC,16		;bytes to move
	PUSH	BC
	LDIR			;and move them
	POP	BC		;get back counter
	POP	HL		;and filename pointer
	LD	DE,mensys	;point to menu heading
	LDIR			;and move it there as well
	RET			;and back we go
;
brdstp	LD	B,A		;move offset
brdo	ADD	HL,DE		;step hl to name
	DJNZ	brdo		;all together
	RET			;then go back
;
clrbrd	CALL	fndsys		;find system info on board
	PUSH	HL		;get address of board
	POP	IX		;for installing next msg#
	LD	BC,15		;bytes to clear -1
	CALL	erase		;and erase the data
	LD	(IX+8),1	;next msg number
	RET			;and go back
;
fndsys	LD	HL,sys		;point to system info
	LD	A,(board)	;get board data to find 1-16
	PUSH	AF		;save it for a minute
	ADD	A,40H		;make it digit A-O
	LD	(mdf+2),A	;insert in multi dl filespec
	LD	(bulrec+4),A	;insert for getting bulletins
	LD	(place),A	;insert in all BRD refs
	LD	(place1),A
	LD	(place2),A
	POP	AF		;get back board number
fndsy0	CP	1		;want the public board
	RET	Z		;back if yes
	DEC	A		;minus 1 for current board
	LD	DE,16		;else offset bewteen board data
	JR	brdstp		;and continue
;
bank1	LD	BC,0		;select code bank 1
	CALL	gua		;IX to USRADD
	JR	setbnk
bank2	LD	BC,1
	JR	setbnk		;select bank 2
bank3	LD	BC,2		;select bank 3
setbnk	LD	A,@bank
	RST	svc
	RET
;
timer	DW	clock		;point to clock
	DB	30		;counts per second
tsec	DB	0		;second counter
tmin	DB	0		;minute counter
clock	DEC	(IX+2)		;minus 1 from time
	RET	NZ		;back if not 1 second past
	INC	(IX+3)		;else add 1 to the seconds
	LD	A,59		;and check for 1 minute
	LD	(IX+2),30	;set for another count
	CP	(IX+3)		;see if 60 seconds past
	RET	NZ		;back if not 1 minute
	INC	(IX+4)		;else add 1 minute
	LD	(IX+3),0	;reset seconds
	RET			;and go back
;
detect	DW	chkcd		;check for carrier detect
chkcd	LD	HL,online	;point to control word
	CALL	carrier		;check for a carrier
	JR	Z,cdtest	;if z, check for dropped carrier
	SET	2,(HL)		;else we have a carrier detected
	RES	4,(HL)		;show normal carrier online
	LD	C,'*'		;show a splat
dexit	LD	HL,79		;where to show CD
bdisp	LD	B,2		;at HL
	JP	toscr0		;set using that VDCTL use its RET
cdtest	BIT	2,(HL)		;1=he was here, 0=no previous connection
	RET	Z		;back if there never was a connect
	RES	2,(HL)		;else we have a dropped condition
	SET	4,(HL)		;set dropped flag in control word
	LD	C,' '		;remove * from screen
	JR	dexit		;and exit now
;
carrier	LD	A,(cdval)	;get carrier detect value
	LD	B,A		;move for testing
	IN	A,(0E8H)	;read from status port
	AND	20H		;mask out bit 5
	CP	B		;check against no CD value
	RET			;Z=no carrier, NZ=CD online
;
calbrd	CALL	gba		;LD IX,(brdadd) board address
	LD	HL,bstat+31	;CALLS
	PUSH	HL		;save address for DE
	LD	B,5
	CALL	dofill		;erase last entry
	CALL	rdix01		;get total callers in IX to HL
	CALL	donum		;calculate
	POP	DE		;bstat+31
	CALL	copy5
	LD	HL,bstat+42	;MSGS
	PUSH	HL		;save for DE
	CALL	dof3		;erase last entry
	LD	L,(IX+2)	;get total msgs
	LD	H,(IX+3)
	CALL	donum
	POP	DE		;where to position data
	CALL	copy3
	LD	HL,bstat+52	;USERS
	PUSH	HL		;SAVE FOR de
	CALL	dof3		;erase last entry
	LD	L,(IX+10)	;get total users
	LD	H,(IX+11)
	CALL	donum
	POP	DE
	CALL	copy3
	LD	HL,bstat+61	;FREE
	PUSH	HL
	CALL	dof3
	LD	A,(msr)		;get msg space left
	LD	L,A
	LD	H,0
	CALL	donum
	POP	DE
	CALL	copy3		;and move them out
	LD	HL,bstat+69	;DOWNLOADS
	PUSH	HL		;save for later
	CALL	dof3		;erase last entry
	LD	L,(IX+12)	;get total downloads on board
	LD	H,(IX+13)
	CALL	donum
	POP	DE
	CALL	copy3
	LD	HL,bstat+78
	PUSH	HL
	LD	B,2
	CALL	dofill		;and erase last entry
	LD	A,(linel)	;get line length (screen width)
	LD	L,A		;get screen size
	LD	H,0
	CALL	donum
	POP	DE
	CALL	copy2
	JP	b2scr		;use RET after moving buffer
;
dof3	LD	B,3		;erase 3 bytes
dofill	LD	(HL),'.'	;insert periods
	INC	HL		;point to next
	DJNZ	dofill		;loop til filled
	RET			;then go back
;
donum	LD	DE,numbuf	;use number buffer
	JP	bindec		;use RET in bindec routine
;
copy5	LD	HL,numbuf	;number buffer
	JR	fmt		;and do it
copy3	LD	HL,numbuf+2	;only move 3 bytes
	JR	fmt
copy2	LD	HL,numbuf+3	;only move 2 bytes
fmt	LD	A,(HL)		;get a byte
	CP	3		;end of line
	RET	Z		;back if yes
	CP	' '		;is it space?
	JR	Z,fmtskp	;skip sticking it in
	LD	(DE),A		;else move to destination
	INC	DE		;and point to next
fmtskp	INC	HL		;point to next
	JR	fmt		;loop til done
;
dskerr	PUSH	AF		;save error code first
	LD	HL,shutdn	;point to shut down msg
	CALL	out		;send to modem
	CALL	delay2		;wait 2 seconds
	LD	A,7		;then drop and leave down the DTR
	OUT	(0EAH),A	;send to modem
	POP	AF		;get back error code
	LD	L,A		;move error code number
	LD	H,0
	CALL	donum		;convert to DECIMAL error#
	LD	HL,ecode	;point to error msgs
	CALL	out
	LD	HL,numbuf
	CALL	out
	CALL	upper		;switch to upper case
dskin	CALL	inkey		;then wait
	CP	'B'		;boot?
	JR	Z,getout	;go if yes
	CP	'R'		;else restart?
	JP	Z,lostcd	;go if yes
	JR	dskin		;else loop for valid code
sax	CALL	exdos		;save banks, unhook it from memory
	JR	geto		;and leave to DOS
getout	CALL	unhook		;remove HOOKS from system
geto	LD	HL,280H		;where hook sub is
	LD	BC,63		;bytes to remove
	CALL	erase		;and 0 them out for return to DOS
	LD	HL,0		;exit to DOS
	LD	A,@exit
	RST	svc		;now
;
quick	CALL	countu		;count total users this board
	CALL	countd		;count total downloads
	CALL	ckroom		;count total msgs
	RET			;and go back
;
	GET	TEXT/ASM	;ascii portion of BBS
	PAGE			;new page
;
tusr	DS	78		;temp user hold
dbuff	DM	'../../..',3	;date buffer
tbuff	DM	'..:..:..',3	;time buffer
year	DB	0
month	DB	0
day	DB	0
numbuf	DM	'.....',3
mkset	DB	0		;used for board switching
akflag	DB	0		;Z=nothing auto killed, NZ=yes
route	DB	0		;used from TERMIN for MSGENT
trkflg	DB	0		;set for message tracking ON (board#)
bulflg	DW	0		;bulletin read flags
upflag	DB	0		;Z=nothing uploaded, NZ=YES!
update	DB	5		;update rate
incir	DB	0		;input storage position
outcir	DB	0		;output position
rsvect	DW	0		;vector of usual RS232 routine
intbit	DB	0		;interupt bit
kilsub	DW	0		;used in msg kill routine
repsub	DW	0		;used in REPLY option
pdcb	DW	0		;printer "	"
vdcb	DW	0		;video control block
board	DS	1		;up to 16 sub boards
brdadd	DS	2		;address of current board info
iocode	DB	0		;read/write flag for bank i/o
temp	DW	0		;used when needed
temp1	DW	0		;"	"
val1	DW	0
val2	DW	0
val3	DW	0
val4	DW	0
val5	DB	0
val6	DW	0		;used for REPLY only!
mcf	DB	0		;mail check flag
smark	DB	0		;used in SYSOP MSG KILL
blknum	DB	0		;all used for XMODEM
rdflag	DB	0
block	DB	0
xmode	DB	0
rec	DW	0
xadd	DW	0
crc	DW	0
xtime	DW	0FFFFH		;xmodem time constant
off1	DW	0		;used for rotating bits
off2	DW	0		;"	"
wsp	DB	108		;word stop parity
bitpat	DB	0		;board bit pattern
prt	DB	0		;NZ=chat to printer
mflag	DB	0		;determines msg# scan method
qflag	DB	0		;use for quick summary
lpoint	DW	0000		;HL to start of input line
usrnum	DW	0000		;users number from his data
vidpas	DB	0		;0=normal output, NZ=bypass output
keypas	DB	0		;bypass RS232 input Z=no NZ=yes
logger	DW	0		;caller since last sysop
inexit	DB	0		;0=normal exit from input 1=abort
online	DB	0		;some of the online bit conditions
cdval	DB	0		;carrier detect value
tablen	DB	2		;amount of spaces to use for tab
ktimer	DW	0		;keyboard time out routine
tmout	DW	49740		;timeout value 30 seconds
ksec	DB	0		;current loop of 30 seconds
tmcred	DB	0		;time credit for uploading
resadd	DW	0		;address to resume display at
edtadd	DW	0		;editing address
msgto	DW	0		;address of TO in msgs
tmax	DB	20		;minutes allowed on
wflag	DB	0		;line wrap 0=off 1=on
wrlen	DB	0		;0=nothing in wrap buffer 1=got chars
len1	DB	0
len2	DB	0
linel	DS	1		;line length
msglin	DS	1		;number of lines per message
try	DB	0
flags	DW	0		;flags address
data	DW	0		;address for search data
usradd	DW	0		;users address
msgadd	DW	0		;message address
dwnadd	DW	0		;download address
msgsz	DW	0		;size of msg buffer
vflag	DB	0		;0=visible 1=invisible
hflag	DB	0		;0=normal inkey in hot, 1=ret without
msgflg	DB	0		;used for MSG98 D,R,N,Q
trkbrd	DB	0		;board number to start track
orgbrd	DB	0		;original board
mask	DB	0		;used for masking different areas
spclkl	DB	0		;used for marking messages and removing
ext	DM	'FPF'		;fastplus file
uf	DM	'USERS:1',13
sf	DM	'SYSINFO:1',13
df	DM	'DL:1',13	;download filespec
mdf	DM	'DLA:1',13	;used for multiDL files
mailf	DM	'MAIL:1',13
othbrd	DM	'BOARDA:1',13
usrec	DM	'USER00YY/LOG:d',13	;for users log records
bulrec	DM	'BULL./FPF:d',13	;used for reading bulletins
stbuff	DS	65		;incoming data buffer
sys	DS	256		;system information
fbuff	DS	32
buff1	DM	'......',3
dummy	DS	256		;buffer for i/o
buffer	DS	9		;buffer for file i/o, input, xfer (1281)
;buffer label + 1281 must be < 7FFFH (<7AFE)
;
	GET	FPINIT/ASM	;standard version
;
	ORG	8100H		;store this in HIGH mem block
	GET	FPLOGO/ASM	;reg user logo
	GET	FPSWLOGO/ASM	;shareware logo
;
	GET	FPEXIT/ASM	;routine to exit to DOS in filter area
;
	GET	FPXLATE/ASM	;xlate table in LOW MEM
;
