	PAGE
;This module simply returns the names of the sub-boards
;which have mail for the user. It does not count the
;number of msgs nor does it clear itself when finished
;reporting. It may be able to be used from a main menu
;as a subroutine. And perhaps following a retrieve trail
;through the various msg bases.
;Copyright 1988 by Mel Patrick
;Filename : MAILACK/ASM
;
mlack	CALL	tmail		;and test for mail
	JP	mdone		;and then continue
;
tmail	CALL	bank1		;select the users bank IX=data
	LD	L,(IX+39)	;get LSB boards
	LD	H,(IX+40)	;get MSB boards
	LD	A,H
	OR	L		;check for mail at all
	JR	NZ,tmail0	;continue if you got mail
	LD	HL,msg34a	;else you ain't got any
	CALL	out		;send it back
	RET			;and go back
tmail0	LD	HL,msg34	;print you have mail in :
	CALL	out		;send it out
	LD	HL,brdnm	;point to start of ASCII board names
	LD	C,'A'		;board letter
	LD	A,1		;start at board 1
tmailp	PUSH	AF		;save board letter
	CALL	brdchk0		;see if mail
	CALL	NZ,mlmark	;show this board if MAIL
	POP	AF		;get back board counter
	LD	DE,16		;offset to next
	ADD	HL,DE		;point HL to it now
	INC	C		;add 1 to board letter
	INC	A		;add 1 for next board
	CP	17		;past all boards?
	RET	Z		;back if yes
	JR	tmailp		;else loop til done
;
mlmark	PUSH	HL		;save pointer to board name
	PUSH	BC		;save counter too
	LD	A,C		;get letter to use
	CALL	output		;send to screen
	LD	A,':'		;then a :
	CALL	output		;then print it too
	LD	B,16		;bytes to print
	CALL	fmtnam		;send ASCII board name to screen
	POP	BC		;get back counter
	POP	HL		;restore pointer
	RET			;and continue
;
mdone	NOP			;just gets around the subroutine
;
