	PAGE
;Terminate Module for FastPlus
;Copyright 1988 by Mel Patrick
;Filename - TERMIN/ASM
;
termin	CALL	resspl		;disable special routines
	LD	HL,msg12	;do you want to TERMINATE?
	CALL	cv12		;look for Y
	JP	NZ,main		;back if not
termtm	LD	A,(ctrl2)	;see if printer/disk still on
	AND	48		;see if bit 4 & 5 active
	JR	Z,npriv		;skip it if off
	LD	HL,msg90	;LEAVE PRIVATE MAIL TO SYSOP?
	CALL	cv12		;look for Y
	JR	NZ,npriv	;go if he don't want to
	CALL	cret		;c/r
	LD	A,1		;set for entry to subroutines
	LD	(route),A	;save it for doing it all
	LD	A,(ctrl2)	;get control bits
	LD	(mask),A	;insert for routine
	CALL	texit1		;and get any mail for you
	LD	A,(mask)	;get mask value
	LD	(ctrl2),A	;save for next time
	XOR	A		;turn off route
	LD	(route),A	;save it
npriv	LD	HL,msg17	;else thanks for calling
	CALL	out
	CALL	delay1		;wait a second
hbort	CALL	resspl		;reset any flags in msgent/asm
	LD	SP,037EH	;reset stack before disk i/o
	CALL	discon		;drop the carrier, reinit the modem
	CALL	clrtyp		;empty buffer
	CALL	cv71		;see if board needs saving
	JR	Z,termns	;skip saving of msg base then
	CALL	svbrd		;else save the current board back to disk
	LD	A,(sysopt+2)	;see if option on next
	AND	32		;Z=off, NZ=print if possible
	JR	Z,termns	;skip if not wanted
	LD	HL,udmsg	;point to update msg
	CALL	lprint		;send HL line to printer
	LD	HL,mensys	;then point to ASCII board name
	CALL	lprint		;send HL to printer
termns	LD	A,(update)	;then check master update rate
	DEC	A		;minus 1 from it
	LD	(update),A	;save it in case
	OR	A		;look for update time
	JR	NZ,tcont0	;skip if no need for update yet
ttup	LD	HL,msg89	;SAVING SYSTEM
	CALL	out		;display on video
	CALL	svsys		;save system info
	CALL	svuser		;save the user file
	CALL	svdown		;save the download and bulletins
	CALL	reupdt		;reset auto update rate
	LD	A,(sysopt+2)	;see if printer option on
	AND	64		;Z=off, NZ=on
	JR	Z,tcont0	;skip if off
	LD	HL,msg89+2	;else point to UPDATE SYSTEM FILES
	CALL	lprint		;send HL to printer
tcont0	LD	HL,buffer	;point to user data
	LD	A,13		;then insert a c/r
	LD	(buffer+78),A	;insert the c/r
	CALL	ckstat		;else see if user delete option on
	LD	A,(track)	;see if hardcopy
	BIT	7,A		;Z=no, NZ=yes
	JR	Z,no2prt	;go if not to printer
	PUSH	AF
	CALL	lprint		;send HL to printer
	POP	AF		;restore again
no2prt	BIT	6,A		;else to disk?
	JR	Z,no2dsk	;skip if both off
	LD	HL,usrec	;point to filename to move
	CALL	crfcb		;create a file control block
	CALL	flinit		;and INIT or CREATE the file
	JR	NZ,opcont	;if error  forget writing
	CALL	peof		;position to end of file
	LD	HL,buffer	;else we got there now write it
wrmore	CALL	fcput		;send to disk file (DE=FBUFF) C=char
	JR	NZ,opoff	;go if failure
	LD	A,(HL)		;read the byte we sent
	INC	HL		;point to next
	CP	0DH		;end of line?
	JR	NZ,wrmore	;continue til done
opcont	CALL	closef		;and close the file
	JR	no2dsk		;and continue
opoff	LD	HL,track	;point to flags
	RES	6,(HL)		;turn off option to disk file
	JR	opcont		;and continue
no2dsk	LD	HL,buffer	;point to buffer again
tnotp	CALL	ckstat		;Z=skip erase, NZ=nuke him
	JR	Z,tnot		;continue if off
	CALL	bank1		;else select bank
	CALL	erause		;erase the callers info
	LD	HL,0		;replace the USER numbers
	LD	(newnm),HL	;so we don't get it again
tnot	CALL	cv75		;see if DL changed and save if yes
	LD	A,(board)	;now always change back to public board
	CP	1		;must be 1-16
	JR	Z,nobld		;continue if public board
	LD	A,1		;else signal for public board
	CALL	cv72		;save it, find it, load it
nobld	JP	bbs		;and restart the BBS
;
hbort0	CALL	discon		;disconnect failed passwords
	CALL	clrtyp
	JR	tnot		;and just restart
;
tbort	LD	HL,msg101	;TIME OUT
	CALL	out		;send it out
	JP	termtm		;FOR NOW
;
ckstat	LD	A,(sysopt)	;check for deleting a drop
	AND	64		;Z=forget it, NZ=delete if NEW usr
	RET	Z		;back if no action
	LD	A,(ctrl2)	;check for enabled option
	AND	64		;Z=no, NZ=yes, delete if NEW and DROP
	RET	Z		;back if not enabled
	LD	A,(HL)		;else check for * or E
	CP	'*'		;if *, CD dropped, set to E
	JR	NZ,cke		;skip setting to E if not *
	LD	A,'E'		;else set to E for erase
	LD	(HL),A		;set it in buffer before print
	RET			;and then back for @PRINT
cke	CP	'E'		;else look for a ' ' or 'E'
	JR	Z,era		;go if E for ERASE
	CP	A		;else set Z flag and return
	RET			;back with nothing to modify
era	JP	nonum		;set NZ flag
;
