;Catalogue Portion of UPDOWN/ASM
;Copyright 1988 by Mel Patrick
;Filename - UPDNCAT/ASM
;
docat	LD	HL,msg73	;CURRENT FILES AVAILABLE
	CALL	out		;send it out
	CALL	brdpat		;get board pattern
	XOR	A		;zero count
	LD	(xmode),A	;save it
	CALL	upper		;switch to upper case
	CALL	bank2		;select download filename bank
	LD	HL,(maxdwn)	;get total download files per
	LD	(val1),HL	;save it
	LD	HL,0FF80H	;loc of last in list (end FFD0)
	LD	(val2),HL	;save pointer in case
catlp	LD	IX,(val2)	;get start of file data info
	LD	A,(IX+3)	;test for a filename here
	OR	A		;0=NO FILE
	JP	Z,noname	;go if none
	LD	A,(board)	;else get board we are in 1-16
	CP	9		;check for board 1-8
	JR	C,blow		;go if lower byte to check
	LD	A,(bitpat)	;else get bit pattern
	AND	(IX+1)		;check against MSB for upper boards
	JR	NZ,docat0	;continue if for this board
	JP	noname		;else continue, not for this board
blow	LD	A,(bitpat)	;get current board bit pattern
	AND	(IX+0)		;check for boards 1-8 (lower)
	JP	Z,noname	;not valid, skip
docat0	BIT	4,(IX+2)	;see if file err
	JR	Z,nfr		;continue if no error
	CALL	bank1		;else check for sysop
	CALL	b7ix75		;see if MASTER
	JP	Z,noname	;skip if not the master
	LD	HL,msg75	;FILE ERROR-->
	CALL	out		;send it out
	JR	disfl		;and display all info about file
nfr	BIT	5,(IX+2)	;look for very private file
	JR	Z,chkpr		;Z=normal NZ=private (sysop eyes only)
	CALL	bank1		;check for master SYSOP to view this
	CALL	b7ix75		;check for master
	JP	Z,noname	;go if not master, can't view it
	LD	HL,msg77	;PROTECTED
	CALL	out
	JR	disfl		;else he's master show him file
chkpr	BIT	1,(IX+2)	;check for VIS/INV
	JR	Z,disfl		;continue if VISIBLE type file
	CALL	bank1		;select user data
	CALL	b7ix73		;check for REMOTE sysop
	JR	NZ,disfl0	;go if remote sysop
	CALL	b7ix75		;see if MASTER
	JR	NZ,disfl0	;if master view
	BIT	2,(IX+74)	;check to see if allowed INV files
	JR	NZ,disfl	;continue if allowed to view (skip INV)
	JP	noname		;else just skip it
disfl0	LD	HL,msg76	;INV FILE>
	CALL	out		;send it out
disfl	CALL	bank2		;else reselect bank of downloads
	LD	HL,(val2)	;get file start data
	PUSH	HL
	POP	IX
	INC	HL
	INC	HL
	INC	HL		;point to filename
	LD	B,12		;bytes to format
	CALL	spclsnd		;send without a c/r
	CALL	sndtab		;send out a TAB
	LD	L,(IX+20)	;get offset to LSB size
	LD	H,(IX+21)
	LD	(val5),HL	;save for time calc
	CALL	cv69		;send ASCII to video
	LD	A,'K'		;show its in K
	CALL	output		;single byte out
	CALL	sndtab		;send out tab again
	LD	HL,(val2)	;get data point
	LD	DE,15		;offset to date
	ADD	HL,DE
	PUSH	IX		;save Index reg
	CALL	cv25		;convert date
	LD	B,8		;length of date
	CALL	hotlin		;print it out
	JP	C,dofile	;back to menu on ctrl c
	POP	IX		;get back reg
	CALL	sndtab		;send out tab again
	LD	HL,msg74	;Accesses :
	CALL	hotret		;look for pause / ctrl c
	JP	C,dofile	;exit if ctrl c
	LD	L,(IX+22)
	LD	H,(IX+23)	;get LSB/MSB of accesses
	CALL	cv69		;send ASCII to video
	LD	A,(nmsup)	;want name suppressed?
	OR	A		;0=YES,NZ=NO
	JR	NZ,dsm		;dont skip name
	CALL	cret		;c/r
	JR	skpnm		;and continue
dsm	CALL	sndtab		;send tab out
	LD	HL,msg39	;FROM:
	CALL	hotret
	JP	C,dofile	;abort on ctrl c
	LD	L,(IX+18)	;get LSB from
	LD	H,(IX+19)	;get MSB from
	CALL	cv41		;save/find/display user
skpnm	LD	HL,dlt		;point to DL time msg
	CALL	out		;send it out (MM)
	LD	HL,(val5)	;get total K
	LD	A,(ustat+77)	;we need the baud rate in use
	CP	'U'		;2400?
	JR	Z,d24
	CP	'H'		;1200?
	JR	Z,d12
	LD	C,34		;else its 34 seconds per K
	JR	dltime		;and continue
d24	LD	C,5		;5 seconds per K
	JR	dltime
d12	LD	C,9		;else 9 seconds per K
dltime	CALL	mul16		;multiply HL * C (rate per K)
	LD	H,L		;then shift it over
	LD	L,A		;HL=total seconds needed
	LD	C,60		;then divide it by 60 seconds
	LD	A,@div16
	RST	svc
	INC	HL		;so its ALWAYS = to at least 1 mm
	CALL	nbta		;convert HL to ASCII in buffer
	LD	HL,numbuf+3	;point to 999 possible minutes
	LD	A,(HL)		;see if a SPACE
	CP	' '		;if yes, insert a 0
	JR	NZ,ns		;continue if not
	LD	A,'0'		;else we need a 0
	CALL	output
	INC	HL		;point to next
ns	CALL	out		;send it out
	CALL	bank2		;select the download bank
	LD	IX,(val2)	;get data pointer
	LD	HL,msg79	;ASCII protocol
	BIT	3,(IX+2)	;Z=ASCII NZ=XMODEM
	JR	Z,itsa		;go if ascii protocol
	LD	HL,msg78	;else its XMODEM
itsa	CALL	out		;send out info
	PUSH	IX
	POP	HL		;move hl to start data
	LD	DE,24		;offset to description
	ADD	HL,DE
	LD	B,56		;bytes to format
	CALL	hotlin		;print the description
	JP	C,dofile	;abort on ctrl c
	CP	13
	CALL	NZ,cret		;c/r if needed
	LD	A,(xmode)
	CP	0FFH		;bypass
	JR	Z,noname	;don't add
	INC	A
	LD	(xmode),A	;count # printed
noname	CALL	bank2		;dl bank
	LD	HL,(val2)	;location of last start point
	LD	DE,80		;offset to next entry
	OR	A		;clear carry flag
	SBC	HL,DE		;point hl to next
	LD	(val2),HL	;save it
	CALL	cv32		;check for carrier
	LD	HL,(val1)	;get total left
	DEC	HL		;minus 1 for this location
	LD	(val1),HL	;save in case of repeat
	LD	A,H
	OR	L		;0=all done total list
	JR	Z,catcom	;skip if completed
	LD	A,(xmode)	;else check for pause
	CP	0FFH		;no pause
	JP	Z,catlp		;loop if no pause
	CP	8		;too many?
	JP	NZ,catlp	;continue til done
	LD	HL,msg107	;for now
	CALL	hot		;Continous/Abort/Next
	CP	'A'		;abort?
	JP	Z,dofile	;back if yes
	CP	'N'		;else next
	JR	Z,catnxt	;go if yes
	CP	'C'		;else continuous
	JR	Z,catstp	;else no stop
	JP	dofile		;else abort it
catnxt	XOR	A		;reset counter
catn	LD	(xmode),A	;save it
	CALL	cret		;do a c/r
	CALL	cret
	JP	catlp
catstp	LD	A,0FFH
	JR	catn
catcom	CALL	resume		;wait for return
	JP	dofile		;wait and back to menu
;
