	PAGE
;User Edit options for FastPlus
;Copyright 1986 by Mel Patrick
;Filename - USREDIT/ASM
;
usred	LD	HL,msg24	;user terminal options
	CALL	out		;send it out
	CALL	bank1		;get user address
	CALL	pram1		;set these parameters
	CALL	shbt		;show currently set bits
	LD	A,0CDH		;now restore CALL SLET to normal
	LD	(onpat),A	;for any other routine
	CALL	inkey		;wait for a key
	PUSH	AF		;save key
	CALL	output		;send it back
	POP	AF		;get it back
	LD	C,(IX+73)	;start at first bit
	CP	'L'		;auto wrap on/off
	JR	Z,ue0
	CP	'C'		;CR+LF
	JR	Z,ue1
	CP	'V'		;Vid Backspace
	JR	Z,ue2
	CP	'B'		;bell
	JR	Z,ue3
	LD	C,(IX+75)	;next bit to check
	CP	'P'		;password INV
	JR	Z,ue4
	CP	'M'		;msg pause
	JR	Z,ue5
	CP	'N'		;enter new password
	JR	Z,newpas	;go if wanted
	CP	'E'		;exit to main menu
	JP	Z,main		;back if yes
	LD	C,'S'		;System Options
	CP	'H'		;HELP?
	CALL	Z,gthelp	;go if yes
	CALL	cv32		;check for carrier
	JR	usred		;else loop for more
;
ue0	LD	A,2		;toggle bit 1 (line wrap)
u73	XOR	C		;toggle it
	LD	(IX+73),A	;save result
u73a	JR	usred		;and start again
ue1	LD	A,8		;toggle cr+lf
	JR	u73
ue2	LD	A,16		;toggle type of backspace
	JR	u73
ue3	LD	A,32		;toggle bell bit
	JR	u73
ue4	LD	A,8		;toggle password bit
u75	XOR	C		;toggle the bit
	LD	(IX+75),A	;save result
	JR	u73a		;and continue
ue5	LD	A,64		;toggle more bit
	JR	u75
;
newpas	LD	HL,msg95	;NEW PASSWORD
	CALL	out		;send it out
	LD	HL,buffer	;point to buffer
	CALL	wrpoff		;turn off word wrap
	LD	A,7		;length for password input
	CALL	uinput		;get upper case input
	CALL	cv32		;check for carrier
	LD	A,(len1)	;else get length entered
	OR	A		;Z=nothing
	JP	Z,usred		;back if no input
	LD	HL,(usradd)	;else point to buffer
	LD	DE,21		;offset to password
	ADD	HL,DE
	EX	DE,HL		;DE=usr address
	LD	HL,buffer	;point to new password
	LD	BC,7		;bytes to move
	LDIR			;and update the password
	LD	HL,msg96	;PASSWORD UPDATED!
	CALL	out		;send out
	JP	usred		;and back to menu
;
shbt	LD	A,0C9H		;insert a RET instead of CALL SLET
	LD	(onpat),A	;stick it in
	LD	HL,uctrl	;point to user controlled
	CALL	out		;show it
	BIT	1,(IX+73)	;line wrap for msg entry
	CALL	shsub		;CR +LF
	BIT	3,(IX+73)	;Z=CR NZ=CR+LF
	CALL	shsub		;Video Backspace
	BIT	4,(IX+73)	;Z=normal 1=video type
	CALL	shsub		;BELL ON/OFF
	BIT	5,(IX+73)
	CALL	shsub		;Password INV/VIS
	BIT	3,(IX+75)
	CALL	shsub		;Pause enabled?
	BIT	6,(IX+75)
	CALL	shsub		;New Password?
	RET			;and go back
;
