	PAGE
;List User Module for FastPlus
;Copyright 1988 by Mel Patrick
;Filename - USRLST/ASM
;
lbu	LD	A,1		;turn on a flag
	LD	(val5),A	;save it for this option
lau	CALL	cret		;do a c/r
	LD	BC,(maxusr)	;get total users
	LD	HL,1		;start with #1
lau0	LD	(val3),HL	;save starting point
	PUSH	BC		;save counter
	CALL	fndusr		;ret--HL,IX=user data address
	JR	NZ,lau1		;skip if not found
	LD	A,(val5)	;test for special routine
	OR	A		;Z=normal NZ=special
	JR	Z,uall		;go if normal
	PUSH	HL		;else save pointer for date conv
	POP	IX		;move address to index
	CALL	brdchk		;test for current board access (38,37)
	JR	Z,lau1		;skip if not allowed
uall	PUSH	HL		;else save for date usage
	POP	IY		;move into IY
laun	CALL	pou		;print out this one users data
	JR	C,laua		;abort if C flag set
lau1	POP	BC		;get back loop counter
	DEC	BC		;minus 1 from counter
	LD	A,B
	OR	C
	JR	Z,lauex		;exit if all done
	LD	HL,(val3)	;else get last user #
	INC	HL		;add 1 to it
	JR	lau0		;else loop for next one
laua	POP	BC		;remove BC counter too
lauex	CALL	resume		;return to continue
	JP	usrmen		;exit if aborted option
;
mbl	CALL	brdavl		;show all boards available
	JR	lauex		;and then continue
;
sfou	CALL	usrfnd		;go find a caller
	JR	lauex		;and then continue
;
usrfnd	CALL	bank1		;select bank 1
	CALL	wrpoff		;disable word wrap
	CALL	cv5		;send out NAME prompt
	LD	HL,buffer	;area to use
	LD	A,16		;allow 16 bytes to be input
	CALL	uinput		;get input
	LD	A,(len1)	;check length
	CP	5		;for less than
	RET	C		;back if too low
	CALL	usrch		;see if matching user
	JR	NZ,sfoub	;go if bad entry
	PUSH	HL		;save hl for later
	POP	IY		;in IY
	CALL	pou		;print out this one user
	JR	usrfnd		;and then repeat til bored
sfoub	LD	HL,msg14	;NOT FOUND
	CALL	out
	JR	usrfnd		;and try again
;
pou	PUSH	HL		;save pointer
	CALL	chksys		;see if master online
	JR	NZ,poun		;go if we get numbers too
	LD	C,32		;see if allowed in SYSEDIT menu
	CALL	chkre0		;allowed remote
	JR	Z,pouno		;skip if not allowed to see #s
poun	POP	IX		;get into IX for numbers
	PUSH	IX		;then save again for later
	CALL	rdix01		;and read in the user#
	LD	DE,numbuf	;point to buffer
	PUSH	DE		;save for printing
	CALL	bindec		;convert to decimal
	POP	HL		;HL points to buffer now
	CALL	out		;send it out
	CALL	comma		;send out a comma
pouno	POP	HL		;restore pointer
	INC	HL		;PRINT ONE USER
	INC	HL		;pointing to name now
	LD	B,16		;bytes to print
	CALL	spclsnd		;send for B chars
	PUSH	IY		;move address back to HL
	POP	HL		;restore the reg data address
	CALL	comma
	PUSH	HL		;save for later
	LD	DE,18		;offset to date
	ADD	HL,DE
	PUSH	HL
	POP	IX		;IX=date address
	CALL	cv25		;convert date
	CALL	hotret		;on screen
	POP	IX		;data to IX regs for boards
	RET	C		;back if A or CTRL C (abort)
	CALL	comma
	CALL	brdac		;and print out the board accesses
	CALL	cret		;C/R
	RET			;else just go back
;
