	PAGE
;Complete CHAT sub-section for FastPlus.
;Copyright 1988 by Mel Patrick
;Filename - CHAT/ASM
;
chatsb	CALL	bank1		;select users bank and address
	CALL	ckol		;Z=remote, NZ=local keyboard
	JR	NZ,chatok	;go if only sysop
	BIT	1,(IX+75)	;Z=not allowed NZ=yes
	JR	Z,nochat	;sorry not avail msg
	BIT	5,(HL)		;Z=bell ON, NZ=bell off
	JR	NZ,nochat	;just exit if bell off
chatok	PUSH	HL		;save pointer
	LD	A,'C'		;show chat attempted
	LD	(ustat+29),A	;insert
	CALL	u2scr		;copy to screen
	LD	HL,msg9		;paging sysop
	CALL	out		;send to both
	POP	HL		;get it back
	LD	A,(btime)	;bell rings allowed
	LD	B,A		;bells to ring
chtlp	PUSH	BC		;save counter
	LD	B,3		;else beep
	LD	A,@sound
	RST	svc
	LD	A,'*'		;and show a splat
	CALL	output		;send out both
	LD	BC,(bdelay)	;get bell delay time
chat0	PUSH	BC		;save counter
	CALL	scan		;scan for a key
	POP	BC		;get back counter
	JR	NZ,chat1	;skip check if nothing there
	CP	81H		;else F1 for chat ok
	JR	Z,gotalk	;go if yes
	CP	'A'		;abort?
	JR	Z,cancht	;cancel if yes
chat1	DEC	BC		;minus 1 from count
	LD	A,B
	OR	C
	JR	NZ,chat0	;keep scanning
	POP	BC		;then get back outside count
	DJNZ	chtlp		;loop for required times
nochat	LD	HL,msg10	;not avail
nocht0	CALL	out		;send out
	JP	main		;and back to menu
cancht	POP	BC		;fix the stack
	LD	HL,abtmsg	;point to aborted message
	JR	nocht0		;and continue
gotalk	POP	BC		;fix stack
	LD	HL,msg11	;I'm here bs
	CALL	out		;send it
	CALL	clrtyp		;empty buffer
talklp	LD	HL,buffer	;buffer to use in case
	LD	A,(linel)	;get max char per line
	LD	(wflag),A	;turn on line wrap
	PUSH	AF		;save AF reg
	XOR	A		;reset timeout count to 0
	LD	(timeout),A	;save it before entering in a line
	CALL	rtime		;reset timeout limits
	POP	AF		;get back reg now
	CALL	linput		;allow upper lower case input
	CALL	cd		;check for carrier
	JP	NZ,main		;exit if carrier lost
	LD	A,(inexit)	;check for exit char
	OR	A		;0=continue 1=exit
	JR	Z,talklp	;continue if not
	JP	main		;else exit
;
