;This module for FastPlus simply blanks the
;screen after x seconds. Performs a CLS and
;disables the cursor.
;Copyright 1988 by Mel Patrick
;Filename - FPBLANK/ASM
;
sblank	LD	A,(screen)	;get screen test
	OR	A		;see if ON/off
	RET	NZ		;back if its OFF (no need to count)
	LD	HL,(rec)	;else get 54-24 second counter
	DEC	HL		;minus 1 from it
	LD	(rec),HL	;save it again
	LD	A,H
	OR	L
	RET	NZ		;back if not timed out
	LD	A,(crc)		;else get second loop timer
	DEC	A		;see if timed out
	LD	(crc),A		;save it
	RET	NZ		;back if its not done yet
	LD	A,1		;show the video is OFF
	LD	(screen),A	;shwo that its OFF now
	CALL	cls		;else clear the video
	JP	curoff		;and turn off the cursor
;
scron	LD	A,(screen)	;see if OFF or on
	OR	A		;test flag
	RET	Z		;back if its already on
	PUSH	HL		;save pointer
	CALL	scrset		;restore set numbers first in case
	CALL	t2scr		;move title to screen
	CALL	b2scr		;move board info to screen
	CALL	draw		;draw the --- line
	CALL	cls1		;reposition the cursor
	POP	HL		;get back position
scron0	PUSH	HL		;save it again
	LD	HL,msg1		;point to the WAITING msg
	CALL	disply		;show it
	XOR	A		;show video is alive now
	LD	(screen),A	;save it
	POP	HL		;then restore and return
	RET			;and go back
;
scrset	LD	HL,0		;set counters up
	LD	(rec),HL	;save it
	LD	A,2		;initial time
	LD	(crc),A		;save it
	RET			;and continue
;
