	PAGE
;Message entry module for FastPlus. Bank 3 used
;for messages. This module is used ONLY for the
;purpose of entering the messages.
;Copyright 1989 by Mel Patrick
;Filename : MSGENT/ASM
;Part of this module is MSGEDIT/ASM as well
;
leave	CALL	bank1		;see if user allowed to leave a msg
	BIT	3,(IX+74)	;Z=no, 1=yes
	JP	Z,sorry		;get poor sod sorry msg
	LD	HL,0		;remove CURRENT MSG ADDRESS
	LD	(val7),HL	;save it
	XOR	A		;remove flag
	LD	(msgflg),A	;save it
	CALL	msgroom		;see if room for msgs
	JR	Z,leave0	;continue if room left
	CALL	mbif		;sorry bank is FULL
	JP	newsry		;and continue
leave0	CALL	bank1		;else return to normal bank
	XOR	A		;set MASK at 0
	LD	(mask),A	;save it (mail direction)
	CALL	gba		;get board address
	CALL	rdix89		;read LSB/MSB msg#
	CALL	mnum		;DE and CONVERT to ASCII
	LD	HL,msg29	;MSG # xxxxx stuff
	CALL	out		;send it out
redolv	CALL	wrpoff		;turn off word wrap
	LD	A,(msgflg)	;check flag from REPLY
	OR	A		;Z=normal NZ=special
	JR	Z,redol0	;continue if normal
	LD	A,(repval)	;test for TO or FROM
	OR	A		;Z=FROM
	JR	Z,m2		;go if 2
	LD	HL,(kilsub)	;else get TO
	PUSH	HL		;save this number
	INC	HL
	LD	A,H
	OR	L		;see if left to ALL
	POP	HL		;back to where it was (TO)
	JR	Z,m2		;NZ=a name, Z=left to ALL (use FRM)
	LD	DE,(usrnum)	;get YOUR #
	OR	A		;see if that was TO = YOU
	SBC	HL,DE		;will =Z if it was
	JR	Z,m2		;go if msg is TO you!
	LD	HL,(repsub)	;else see if it was FROM you
	OR	A		;clear the carry
	SBC	HL,DE		;subtract
	JR	Z,uto		;use TO name if thats the case
	CALL	cret		;do a carriage return
	LD	A,'A'		;save this one
	PUSH	AF		;for later
	CALL	output		;send out character
	LD	A,':'		;colon
	CALL	output		;send it out
	LD	HL,(kilsub)	;TO name
	CALL	cv41		;use this one OR
	POP	AF		;get back letter
	INC	A		;add 1 to it (B)
	CALL	output		;send it out
	LD	A,':'		;send it out
	CALL	output		;this one
	LD	HL,(repsub)	;use FROM name
	CALL	cv41		;now select
	CALL	upper		;switch to upper case
askagn	LD	HL,subm4	;ask who now
	CALL	hot		;send it out
	CP	'A'		;use TO
	JR	Z,uto		;go if yes
	CP	'B'		;else from?
	JR	Z,m2		;go if yes
	CP	'E'		;else EXIT?
	RET	Z		;back if yes
	CALL	cd		;else check for carrier
	RET	NZ		;back if lost
	JR	askagn		;else loop
uto	LD	HL,(kilsub)	;use TO name
	JR	m22		;and continue
m2	LD	HL,(repsub)	;get FRM # (from him to YOU)
m22	PUSH	HL		;save pointer
	CALL	cv39a		;print TO: 
	POP	HL		;retrieve it again
	CALL	cv41		;save/find/display user
	JP	spclx		;and continue now
redol0	CALL	cv39a		;print TO prompt
	CALL	type2		;INPUT routine in INPUT/ASM
	LD	A,(HL)		;see if '#' sign used
	CP	'#'		;if yes, then allowed to use number
	JR	NZ,nohunt	;go if not using numbers
	CALL	hunt		;Z=found, HL=data address
	JR	NZ,nohunt	;go if not found
	PUSH	HL		;save pointer
	CALL	cv39a		;To:
	POP	HL		;restore pointer
	CALL	dspnam		;and show this users name
	JR	spclx		;Z=found him, HL=his data address
nohunt	CALL	cv32		;check carrier
	CALL	cv18		;check length of input
	JP	Z,msgmen	;back to menu if nothing
	LD	HL,buffer	;point back to buffer now
	LD	DE,msg41	;else check for ALL
	LD	B,4		;bytes to check
cfall	LD	A,(DE)		;check against buffer
	CP	(HL)		;if same ok, else must be name
	JR	NZ,nolall	;continue elsewhere if not to all
	INC	HL		;else point to next
	INC	DE		;and in pointer
	DJNZ	cfall		;loop for word + c/r
	LD	HL,0FFFFH	;else marker for ALL
	JR	spcall		;and handle it
nolall	LD	A,(len1)	;else check length
	CP	5		;must be >5
	JP	C,msgmen	;abort if too short
	CALL	usrch		;go find this user
	JR	Z,spclx		;go if a valid user
	LD	HL,err8		;else sorry not a valid user
prtsry	CALL	out		;send to remote
	JP	redolv		;then reprompt
spclx	LD	(msgto),HL	;Save TO address
	PUSH	HL
	POP	IX		;check to see if user allowed on board
	LD	A,(msgflg)	;test for MAIL entry sub
	OR	A		;Z=nope, NZ=yep
	JP	NZ,lv3a		;continue if from a CALL
	CALL	brdchk		;Z=not allowed, NZ=allowed
	JR	NZ,lv3		;continue if they have access
lv1a	LD	HL,err9		;else let user know
	JR	prtsry		;and show it
lv3	CALL	b7ix74		;test bit 7, ix+74
	JR	Z,lv1a		;give sorry if not
lv3a	CALL	rdix01		;get LSB/MSB user# TO
	LD	A,(IX+75)	;test for MASTER SYSOP
	BIT	7,A		;Z=nope, NZ=special for svmsg
	JR	Z,spcall	;skip if not master sysop online
	AND	30H		;mask out all bits except direction ones
	LD	(mask),A	;else save mail direction
spcall	LD	IY,buffer	;where to format message
	CALL	sviy89		;insert LSB/MSB user number
	CALL	gua		;get user address
	LD	HL,(usrnum)	;get this users number
	LD	(IY+10),L	;insert from
	LD	(IY+11),H	;msb from
	CALL	date		;get todays date
	LD	HL,year		;then move out the date
	LD	DE,buffer	;where to move it too
	CALL	cv20		;BC=3, LDIR
	LD	HL,msg26	;SUBJECT?
	CALL	out		;send out prompt
	LD	HL,buffer+12	;where to store subject (variable)
	LD	A,25		;maximum input length
	CALL	linput		;allow lower case
	LD	A,(msgflg)	;test for MAIL sub
	OR	A		;Z=nope
	JR	Z,spcal		;go if normal
	CALL	cd		;else check carrier
	RET	NZ		;back if lost
	JR	spcal0		;and skip next check
spcal	CALL	cv32		;check carrier
spcal0	CALL	cv18		;check length of input
	JR	NZ,notmd	;skip if not standard msg default
	LD	(HL),0FFH	;else replace c/r with flag byte
notmd	LD	(IY+7),0	;reset any bit controls
	CALL	upper		;switch to upper case for input
	CALL	rdiy89		;test for ALL, can't leave pri msg
	INC	HL		;make it 0000 if it was FFFF
	LD	A,H
	OR	L		;check for all 0's
	JR	Z,notpm		;skip if msg left to all
	LD	HL,msg30+1	;private msg?
	CALL	cv12		;look for Y
	JR	NZ,notpm	;skip if not private message
	SET	1,(IY+7)	;private message
notpm	CALL	b7ix75		;check for master sysop
	JR	NZ,mms		;go if master at the helm
	LD	C,1		;check first bit 1
	CALL	chkre0		;see if remote sysop
	JR	Z,notcon	;skip if not a sysop of any kind
mms	CALL	rdiy89		;get LSB/MSB TO:
	INC	HL		;make it user + 1 or 0's
	LD	A,H		;test for all 0's
	OR	L		;0=left to ALL don't protect
	JR	NZ,notcon	;skip prompt if not allowed to protect
	LD	HL,msg31	;else want a protected message
	CALL	cv12		;look for a Y
	JR	NZ,notcon	;continue if not
	SET	0,(IY+7)	;protect the message too
notcon	LD	HL,msg32	;Correct prompt
	CALL	cv12		;look for Y
	JR	Z,okcor		;continue if correct
	LD	A,(msgflg)	;test for REPLY in effect
	OR	A		;Z=no, NZ=yes
	RET	NZ		;back if REPLY was in effect
	JP	msgmen		;else we abort to menu
okcor	CALL	lower		;toggle to lower case now
	CALL	cv45		;2 c/rs
texit1	LD	HL,buffer+38	;point to start of lines for input
	LD	(val1),HL	;save it
	CALL	cv46		;enable word wrap if needed
	LD	HL,1		;starting line number
	LD	(val2),HL	;save it
	LD	A,(msglin)	;get max # lines
	LD	(val3),A	;save in for next loop
	LD	L,A
	LD	H,0		;move for ASCII conv
	LD	DE,msg27	;## lines max
	CALL	bindec		;convert to ASCII
	LD	HL,msg27+3	;then print it
	CALL	out		;send it out
	CALL	dorule		;and do a ruler please
	LD	A,(route)	;see if from BULL INPUT
	CP	2		;2=YES
	JR	Z,prule1	;skip prompts if bull input
	LD	A,(ctrl2)	;check for termin special request
	BIT	6,A		;see if new user
	JR	NZ,newone	;go if new user on system
	BIT	7,A		;else a reg user?
	JR	NZ,regone	;go if a regular one
prule1	XOR	A		;else we don't really know
prule2	LD	(val5),A	;turn off prompts option
	JR	rent		;and continue
newone	BIT	0,A		;if new user want prompts?
	JR	Z,prule1	;skip if no
	LD	HL,lstone	;else point to question list
	LD	(val4),HL	;save pointer
	LD	A,(lst1)	;get total questions
	JR	prule2		;and continue
regone	BIT	1,A		;see if poll questions in effect
	JR	Z,prule1	;continue if off
	LD	HL,lsttwo	;else point to second set of prompts
	LD	(val4),HL	;save pointer
	LD	A,(lst2)	;get total questions entered
	JR	prule2		;and continue
rent	CALL	cret		;c/r
	CALL	lower		;select lower case
rmin	LD	A,(route)	;test for special handling
	OR	A		;Z=no, NZ=yes
	JR	Z,rmin0		;skip if normal
	LD	A,(val5)	;see if any prompts in effect
	OR	A		;Z=no NZ=yes
	JR	Z,rmin0		;continue if not
	PUSH	AF		;save counter
	LD	HL,(val4)	;else get pointer
	CALL	out		;send out prompt
	INC	HL		;point to start of next line
	LD	(val4),HL	;save for next time
	POP	AF		;get back counter
	DEC	A		;minus 1 from counter
	LD	(val5),A	;save remaining prompts left
rmin0	CALL	lnumb		;print line number and :
	LD	HL,(val1)	;get address for text entry
	LD	A,(linel)	;get line length allowed
	CALL	input		;and go get line input
	LD	A,(msgflg)	;CALLed from MAIL routine?
	OR	A		;Z=no, NZ=yes
	JR	Z,niff		;continue if not
	CALL	cd		;else check for carrier
	RET	NZ		;back if gone
	JR	nft0		;and skip next checks
niff	LD	A,(route)	;check for call from Termin routine
	OR	A		;0=no NZ=yes
	JR	Z,nft		;skip if not from termin routine
	CALL	cd		;else check for special handling
	RET	NZ		;back if cd dropped
	JR	nft0		;else skip to next section still there
nft	CALL	cv32		;check for carrier
nft0	CALL	cv18		;check length of input
	JR	Z,pedit0	;and continue for possible edit etc
	CALL	lstep0		;move HL to next address
	LD	(val1),HL	;save it now
	CALL	decv3		;LD a VAL3 and dec
	PUSH	AF		;save, 2 checks to make
	CP	1		;if on last line, turn off wrap
	CALL	Z,wrpoff	;do it regardless
	POP	AF		;get back count
	OR	A		;if 0, then all done
	JP	NZ,rmin		;loop back if not done yet
	JR	pedit		;skip end marker placment
pedit0	LD	HL,(val1)	;get start of last position
	LD	(HL),0FFH	;insert end marker on line
pedit	CALL	upper		;use upper case
	LD	A,(route)	;test for special handling
	CP	2		;see if from BULL INPUT
	JR	Z,pedit1	;go if yes
	OR	A		;Z=none, NZ=special from termin
	JP	NZ,spclsv	;and save to disk/printer
pedit1	LD	HL,subm3	;sub menu 3, what to do now
	CALL	hot		;and show it
	CP	'S'		;save the message?
	JP	Z,svmsg		;go if yes
	CP	'L'		;list the message
	JP	Z,lstmsg	;go if yes
	CP	'C'		;continue with the entry
	JP	Z,cent		;go if yes
	CP	'E'		;edit a line number?
	JP	Z,edmsg		;go if yes
	CP	'A'		;abort the message entry
	JR	NZ,pedit	;back again if not
	CALL	cv32		;check for carrier
	LD	A,(msgflg)	;check for CALL active
	OR	A		;Z=no, NZ=yes
	RET	NZ		;back if from CALL
	LD	A,(route)	;see if from BULL INPUT
	OR	A		;Z=no, NZ=YES
	JR	NZ,fgbul	;go if we want to forget it
	JP	msgmen		;and back to menu for now
;
fgbul	POP	HL		;remove return address
	JP	bexit		;and forget writing to disk
;
cent	CALL	cv46		;enable word wrap if set
	LD	A,(val3)
	OR	A		;test it
	JP	Z,pedit		;skip option if full
	CP	1		;else at last line?
	CALL	Z,wrpoff	;turn off word wrap if yes
	LD	BC,1		;use for a counter
	LD	HL,buffer+38	;start of message buffer
cent0	LD	A,(HL)		;look for 0FF
	CP	0FFH		;if found then we are at next line
	JR	Z,cent1		;go if found
	INC	BC		;add 1 to line counter
	CALL	lstep		;step HL to proper line number
	JR	cent0		;loop til 0FF found
cent1	LD	(val2),BC	;save line number we are going to work on
	LD	(val1),HL	;and the position we are starting at
	JP	rent		;and resume entry
;
	GET	MSGEDIT/ASM	;editing module
;
lstmsg	CALL	cv45		;2 cr/s
	LD	HL,buffer+38	;point to start of text
	LD	(val1),HL	;save it
	LD	HL,1		;start at digit 1
	LD	(val2),HL	;save it too
	LD	A,(msglin)	;get the maximum number of lines
	LD	B,A		;save it
lstlp	LD	HL,(val1)	;get starting position
	LD	A,(HL)		;get first byte in case
	CP	0FFH		;end of msg
	JP	Z,pedit		;list no more if yes
	PUSH	BC		;save counter
	CALL	lnumb		;and show line number
	LD	A,(linel)	;get line length
	LD	B,A		;move for line display
	LD	HL,(val1)	;get line start
	CALL	fmtnam		;else send to video display
	POP	BC		;get back line counter
	CALL	lstep0		;add LINEL to HL to get next
	LD	(val1),HL	;save it
	DJNZ	lstlp		;list til done
	JP	pedit		;and back to edit options
;
svmsg	LD	A,(route)	;check for route to ret to
	OR	A		;so return to termin routine
	RET	NZ		;back if from TERMIN or BULL INPUT
	CALL	bank3		;select message bank
	LD	A,(mask)	;check for special mail direction
	OR	A		;0=process normally
	JP	NZ,spclsv	;use special save if wanted
	LD	A,1		;else set save or killed flag
	LD	(mkset),A	;save incase of bank switching
	CALL	gba		;get board address
	LD	IY,buffer	;point to buffer address
	CALL	rdix89		;get the msg number
	LD	(IY+5),L	;insert in msg
	LD	(IY+6),H	;"	"
	INC	HL		;add 1 for next msg number
	CALL	svix89		;save HL in IX+8,9
	LD	HL,buffer	;where to pick from
	LD	DE,(msgadd)	;address to store msg at
	LD	BC,12		;bytes to always move
	LDIR			;do it
	LD	HL,buffer+12	;1st set of variable bytes (SUB)
	LD	B,25		;maximum characters to count
	CALL	copymg		;go move and count
	LD	HL,buffer+38	;offset to start of text input
	LD	(val1),HL	;save it
	LD	A,(msglin)	;get maximum lines used
	LD	B,A		;move into loop
svmsg2	PUSH	BC		;save counter
	LD	HL,(val1)	;get pointer to start of string
	LD	A,(linel)	;get line length
	LD	B,A		;move to B for copying out
	CALL	copymg		;and copy message out
	POP	BC		;fix stack in case
	CP	0FFH		;end of msg?
	JR	Z,svmsg3	;go if early end
	PUSH	DE		;save pointer
	CALL	lstep0		;step to next line
	LD	(val1),HL	;save for next time
	POP	DE		;get back pointer
	DJNZ	svmsg2		;loop til all saved
svmsg3	LD	HL,(msgadd)	;get message address
	PUSH	HL		;move for storing length
	POP	IX		;IX=length to use
	OR	A		;clear the carry
	EX	DE,HL		;DE=start now, HL=end
	SBC	HL,DE		;find the difference
	LD	(IX+3),L	;insert lsb length
	LD	(IX+4),H	;insert msb length
mres	LD	HL,msg33	;SAVED!
	CALL	out		;send it
	CALL	ckroom		;update totals now
	CALL	calbrd		;update board stats
	LD	A,'M'		;show message left
	LD	(ustat+30),A	;insert in user area
	CALL	bank1		;select users bank again
	CALL	gmt		;get TO address
	LD	IY,buffer	;point to buffer to check for ALL (FF)
	CALL	rdiy89		;get LSB/MSB user #
	INC	HL		;add 1 to it
	LD	A,H
	OR	L		;if 0, then ALL
	JR	Z,skpset	;back if msg for ALL
	CALL	setml		;else set mail for TO user
	LD	A,(track)	;see if marking ON
	BIT	4,A		;Z=no, NZ=YES
	JR	Z,skpset	;skip if off
	CALL	b7ix75		;Z=no, NZ=yes
	JR	Z,skpset	;if Z, then not
	LD	A,'M'		;insert a symbol
	LD	(ustat),A	;insert in record
skpset	CALL	u2scr		;and copy to video
	CALL	bank1		;select users bank (FROM)
	LD	L,(IX+32)	;get total msg entered
	LD	H,(IX+33)
	INC	HL
	LD	(IX+32),L
	LD	(IX+33),H	;save after adding 1
	LD	A,(msgflg)	;CALLed from MAIL?
	OR	A		;Z=no, NZ=yes
	RET	NZ		;back if yes
	JP	msgmen		;and back to menu
;
spclsv	LD	A,(ctrl)	;get control byte
	BIT	1,A		;Z=printer not there, NZ=yep printer
	JR	NZ,spsv0	;continue if printer there
	CALL	prtoff		;turn off printer option
	JP	Z,svmsg		;resume normally if no further options
spsv0	CALL	mval5		;Z=no disk file, NZ=yes
	JP	Z,spsv2a	;continue if no disk file req
	LD	HL,mailf	;else we will create a disk file
	CALL	crfile		;create or open the file
	JR	C,spsv2		;if just created, don't peof
	JR	Z,spsv1		;continue if opened ok
	CALL	dskoff		;turn off disk option
	JP	Z,svmsg		;resume normally if all failed
spsv1	CALL	peof		;extend the file
spsv2	CALL	bank1		;select users bank
	PUSH	IX		;move to HL for printer/disk
	POP	HL
	INC	HL
	INC	HL		;point to his ASCII name
	LD	B,16		;maximum of 16 bytes to use
	CALL	spcprt		;and use special printer routine
	CALL	chkopt		;check printer disk options
	JP	Z,svmsg		;normal if screwed up
	LD	HL,dbuff	;point to date buffer
	PUSH	HL
	CALL	thdate		;get the date
	POP	HL
	LD	B,9		;print the date first
	CALL	spcprt
	CALL	chkopt		;check disk printer options
	JP	Z,svmsg		;normal processing if yes
	LD	C,' '		;separate by space
	CALL	single		;do single write/print
	LD	HL,tbuff	;then get the time
	PUSH	HL
	LD	A,@time
	RST	svc
	POP	HL
	LD	B,9		;and then print the time
	CALL	spcprt		;and then do a special print
	CALL	chkopt		;check printer/disk
	JR	Z,spfail	;normal if failure
spsv2a	LD	C,13		;then do a c/r
	CALL	single		;now
	LD	HL,buffer+38	;starting point for msg
	LD	(val1),HL	;save starting point
	LD	A,(msglin)	;get total lines allowed
	LD	B,A		;move to loop counter
spclp	PUSH	BC		;save counter
	LD	HL,(val1)	;get pointer to start
	LD	A,(linel)	;get line length
	LD	B,A		;move to loop
	CALL	spcprt		;and do a special direction
	POP	BC		;get back counter
	CP	0FFH		;end of MSG?
	JR	Z,spdone	;go if all done with msg lines
	CALL	chkopt		;check printer/disk options
	JR	Z,spfail	;back if failed
	CALL	lstep0		;step HL to next address
	LD	(val1),HL	;save for next time
	DJNZ	spclp		;loop for x lines or end
spdone	CALL	mval5		;Z=no close, NZ=yes, CLOSE
	JR	Z,spdon0	;continue if no close
	LD	C,0FFH		;insert end marker
	CALL	sin0		;and write to disk
	CALL	chkopt		;make sure option still alive
	JR	Z,spfail	;go if option failed
	CALL	closef		;and close the file
	JR	Z,spdon0	;continue if no error
	CALL	dskoff		;turn off disk option if bad close
spfail	JP	svmsg		;cause we had an error
spdon0	LD	A,(route)	;check for route used
	OR	A		;Z=normal NZ=from termin routine
	RET	NZ		;back if from termin routine
	CALL	gba		;get board address
	CALL	rdix89		;get last message number
	INC	HL		;add for next msg
	CALL	svix89		;save HL in IX+8,9
	JP	mres		;and resume in remainder of routine
;
spcprt	LD	A,(HL)		;test for anymore text first
	CP	3		;end?
	RET	Z		;back if yes
	CP	0FFH		;end of msg?
	RET	Z		;back if yes
	CALL	mval5		;Z=no disk output
	JR	Z,sppr1		;continue if no disk output
	CALL	fcput		;write to disk file (DE=FBUFF) C=char
	JR	Z,sppr1		;continue if no error
	CALL	dskoff		;turn off disk option
	RET	Z		;back if all options off
sppr1	CALL	mval4		;look for printer output Z=no, NZ=YES
	JR	Z,sppr2		;continue if no printer output
	LD	C,(HL)		;else get back byte
	CALL	prt1c		;and write to printer
	JR	Z,sppr2		;continue if ok
	CALL	prtoff		;turn off printer option
	RET	Z		;back if all options off
sppr2	LD	A,(HL)		;get byte just printed
	CP	13		;look for c/r
	RET	Z		;back if end
	INC	HL		;point to next character
	DJNZ	spcprt		;loop for their names
	LD	C,13		;if whole line printed do a c/r
	CALL	single		;send out single char
	RET			;and then return to caller
;
single	CALL	mval4		;printer, Z=no, NZ=yes
	JR	Z,sin0		;continue if not to printer
	PUSH	BC		;else save char
	CALL	prt1c		;send to printer
	POP	BC		;get back character
	JR	Z,sin0		;continue if successful
	CALL	prtoff		;turn off printer option
	RET	Z		;back if all options off
sin0	CALL	mval5		;test for disk, Z=no, NZ=yes
	RET	Z		;back if disk output not enabled
	CALL	fput		;write C to disk (DE=FBUFF)
	RET	Z		;back if successful
	CALL	dskoff		;turn off disk option
	RET			;and go back
;
kilmsg	CALL	chksys		;see if master/online
	JR	NZ,kilcnt	;continue if allowed
	CALL	bank1		;select users bank
	BIT	4,(IX+74)	;see if user has access to kill
	JP	Z,sorry		;let him know he don't have access
kilcnt	CALL	csmark		;check flag
	JR	Z,kilc0		;continue if not
	LD	HL,(xadd)	;else get address
	LD	C,(HL)		;get LSB
	INC	HL		;point to next
	LD	B,(HL)		;read MSB
	INC	HL		;point to next
	LD	(xadd),HL	;save for next time
	CALL	part3		;sve BC, set flag to msg number
	JP	NZ,forkil	;go if all removed
	JR	kilc1		;else valid number continue
kilc0	CALL	gtnum		;get message number to work with
	JP	NZ,msgmen	;back if invalid input
kilc1	CALL	fndnum		;find msg Z=found NZ=not found
	JR	NZ,kilnf	;go if not found
	CALL	ckpro		;check for TO FRM protection of msg
	JR	Z,kilsys	;process if all OK!
	JR	nfm0		;no acknowledge of any msg here
nfm	CALL	out		;send it
nfm0	JP	msgmen		;and leave
kilnf	LD	HL,msg45	;msg not found
	JR	nfm		;and continue
kilsys	BIT	0,(IY+7)	;see if protected msg
	JR	Z,sysspl	;skip to check for marked mode
	CALL	chksys		;see if master online
	JR	NZ,sysspl	;go if master sysop online
	LD	C,16		;if he wants to kill msg
	CALL	chkre0		;check remote sysop status
	JR	NZ,sysspl	;continue if allowed to kill
	LD	HL,msg36	;protected MSG
	JR	nfm		;else not allowed to remove it
sysspl	CALL	csmark		;check marked condition
	JR	Z,kilok		;continue if not in marked mode
	LD	A,(track)	;else check track flag
	BIT	5,A		;Z=no ask, NZ=ASK
	JR	Z,killit	;go if no prompts wanted
kilok	CALL	dphead		;show header stuff
	JP	C,retabt	;abort on C flag set
	CALL	upper		;switch to upper case
	LD	HL,msg43	;Kill it
	CALL	cv12		;look for Y
	JR	NZ,kdone	;must be Y to process
killit	CALL	mkill		;and go remove this message
	LD	A,'K'		;show a msg was killed
	LD	(ustat+31),A	;insert in user stats
	CALL	u2scr		;copy to video
	LD	HL,msg44	;msg removed
	CALL	out
	LD	A,1		;set remove flag for switching
	LD	(mkset),A	;save it
	CALL	calbrd		;and redisplay board stats
	LD	HL,(kilsub)	;check for msg to ALL first
	INC	HL		;make it possible 0
	LD	A,H
	OR	L		;if msg to all skip next section
	JR	Z,kdone		;skip if left to ALL
	LD	HL,(usrnum)	;else save this users number
	PUSH	HL		;for later to restore it
	LD	HL,(kilsub)	;get TO #
	LD	(usrnum),HL	;insert for searching for more mail
	LD	(val3),HL	;insert for finding this users data
	CALL	fndnam		;check for any more mail to this TO#
	JR	Z,morml		;Z=more mail NZ=no mail for user
	CALL	fndusr		;else find his data
	JR	NZ,kilnon	;skip if ALL or del
	PUSH	HL		;move data reg
	POP	IX
	CALL	rsetml		;else reset their mail flag
	JR	kilnon		;and continue
morml	CALL	fndusr		;find user TO#
	JR	NZ,kilnon	;skip if ALL or DELETED
	PUSH	HL
	POP	IX		;move pointer
	CALL	setml		;turn on mail flag for them
kilnon	POP	HL		;get back this users number
	LD	(usrnum),HL	;insert back to normal
kdone	LD	A,(msgflg)	;test for a CALL to here
	OR	A		;Z=normal NZ=from other routine
	RET	NZ		;back if flag set
	CALL	csmark		;see if marked kill active
	JP	NZ,kilcnt	;continue til 00 found
	JP	msgmen		;and back to menu
;
copymg	LD	A,(HL)		;get a byte
	CP	0FFH		;no subject?
	JR	Z,svmsg1	;if yes, only save 1 byte
	CP	13		;else end of line?
	JR	Z,svmsg1	;copy and save
	LD	(DE),A		;else just move it
	INC	DE		;point to next
	INC	HL		;again
	DJNZ	copymg		;loop for count of B
	RET			;and then go back, full line
svmsg1	LD	(DE),A		;insert in memory
	INC	DE		;point to next
	RET			;and go back
;
shmail	CALL	tmail		;show location of mail
newsry	CALL	resume		;return to continue
	JP	msgmen		;and back to menu
;
dphead	CALL	bank3		;select msg bank
	CALL	gmay		;msg address in IY
	LD	L,(IY+5)	;get msg #
	LD	H,(IY+6)
	CALL	mnum		;DE to buffer and CONVERT to ASCII
	CALL	cret		;c/r
	LD	HL,msg28	;print MSG# .....
	CALL	out
	BIT	2,(IY+7)	;see if READ yet
	JR	Z,mnry		;go if not read yet
	LD	HL,mir		;else message was read
	CALL	out		;send it out
mnry	BIT	1,(IY+7)	;see if private msg
	JR	Z,dph0		;skip if not private
	LD	HL,msg37	;else PRIVATE msg
	CALL	out		;send it out
dph0	CALL	rdiy89		;get TO number (user)
	LD	(val3),HL	;save for search
	LD	(kilsub),HL	;TO: number in case of KILL! (REPLY)
head0	CALL	cv39a		;TO:
	CALL	cv41a		;find/display user
	LD	HL,msg39	;Fm : 
	CALL	out		;display FRM prompt
	CALL	bank3		;selec msg bank again
	LD	L,(IY+10)	;get FROM number
	LD	H,(IY+11)	;"	"
	LD	(repsub),HL	;save for reply option
	CALL	cv41		;save/find/display user
head1	LD	HL,msg26	;SUBject
	CALL	out		;send it out
	CALL	bank3		;re-select msg bank
	LD	HL,(msgadd)	;get start of address
	LD	DE,12		;offset to subject
	ADD	HL,DE		;HL=subject
	LD	A,(HL)		;test for null subject
	CP	0FFH		;=null subject
	JR	NZ,prsub	;go if subject exists
	LD	HL,msg40	;GENERAL subject else
prsub	LD	B,25		;maximum length
	CALL	hotlin		;and show it
	RET	C
	CP	'N'
	RET	Z
	CP	13		;c/r
	JR	Z,prsub0	;continue if c/r
	CALL	cret		;else do one
prsub0	LD	HL,msg42	;Date
	CALL	out		;send it
	LD	HL,(msgadd)	;get msg address
	CALL	cv25		;convert date
	CALL	out		;send it out
	CALL	qtest		;see if in SUM mode, Z=no, NZ=yes
	RET	Z		;back if off
	CALL	cret		;c/r
	XOR	A		;empty A reg
	CP	A		;set Z flag, made it through
	RET			;and finally return
;
rtind	CALL	cv49		;see if access allowed
	CALL	smn		;show message range
rnewdo	CALL	cd		;see if carrier still here
	JP	NZ,hbort	;go if lost
	LD	HL,mnword	;MSG# (to retrieve?)
	CALL	gtnum0		;print prompt and wait
	JP	NZ,msgmen	;menu if invalid number
	CALL	fndnum		;go find message
	JR	NZ,mnf		;go if not found
	CALL	ckpro		;else check TO FRM protections
	JR	Z,rtok		;go if ok to retrieve
mnf0	CALL	out		;else send out answer of some sort
	JR	rnewdo		;redo input
mnf	LD	HL,msg45	;MSG NOT FOUND
	JR	mnf0		;and print it
rtok	CALL	dphead		;display heading
	JP	C,retabt	;back to menu if CTRL C or A
	CP	'N'		;next msg
	JR	Z,rtind		;go if yes
	CALL	shline		;now print the msg lines
	JP	C,retabt	;back on A or CTRL C (menu)
	CALL	repopt		;see if REPLY allowed
	JR	rtind		;and then for next msg
;
retnew	CALL	cv49		;see if access allowed
	LD	HL,trknew	;tarck new msgs
	LD	(which+1),HL	;save it for subroutine
	LD	HL,retnew	;where to resume with new scan
	LD	(where+1),HL	;save this one too
	LD	A,(track)	;see if new tracking on
	BIT	1,A		;bit 1 Z=no, NZ=yes
	CALL	NZ,intrk	;setup for new scan on all
donew	CALL	cret		;c/r
	PUSH	IX		;move users data to HL
	POP	HL
	LD	DE,41		;offset to retreive map
	ADD	HL,DE
	LD	A,(board)	;get board
	CALL	addsu0		;used to retrieve an offset
	LD	C,(HL)		;get LSB #
	INC	HL		;point to msb
	LD	B,(HL)		;get MSB #
	INC	BC		;add 1 to last number retrieved
	LD	(val2),BC	;save number for testing
	JR	newent		;and enter seq routine for that point
;
qcksum	CALL	cv49		;see if access allowed
	CALL	upper
	LD	A,1		;turn on quick summary
	LD	(qflag),A	;set it up
	LD	HL,msg50	;<F>orward / <N>ew
	CALL	hot		;show it
	CP	'F'		;want forward?
	JR	Z,do4		;go if yes
	JR	donew		;else do new messages only
;
forwrd	CALL	cv49		;see if allowed to read
do4	CALL	smn		;show range
	LD	HL,mnword	;prompt to use for now
	CALL	gtnum0		;print it and wait for #
	JP	NZ,allrd	;if 0 number, forget it
newent	LD	A,1		;set flag for msg scan
	LD	(mflag),A	;for relative serach
	LD	(spclkl),A	;enable spcl KILL flag
	CALL	fndnum		;go find closest msg number
	JP	NZ,allrd	;continue if out of range
	LD	HL,dummy+1	;gives lots of room
	LD	(xadd),HL	;save for the numbers to kill
forseq	CALL	cv32		;check for carrier
	CALL	ckpro		;else we got one, check protection
	JR	Z,rtok0		;display if ok
fseq	CALL	bank3		;select msg bank again
	LD	HL,(msgadd)	;else get message address
	PUSH	HL		;move offset for next
	POP	IY		;use index to get length
	LD	E,(IY+3)	;LSB length
	LD	D,(IY+4)	;MSB length
	ADD	HL,DE		;point HL to next
	LD	(msgadd),HL	;save next address
	LD	A,(HL)		;check for last msg
	OR	A		;test for any msg there
	JR	NZ,forseq	;continue if still more msgs
	JR	forchk		;see if tracking NEW msgs
conmsg	CALL	cv32		;check for carrier
	JP	newsry		;return to continue, then menu
rtok0	CALL	dphead		;show heading
	JP	C,retabt	;exit on ctrl C or A
	LD	C,A		;save character
	CALL	qtest		;test for summary mode
	JR	NZ,noupd	;don't update ret number if yes
	LD	A,C		;then get it back
	CP	'N'		;next msg
	JR	Z,fseq		;don't update if SKIP in effect
	CALL	shline		;show msg lines
	JP	C,retabt	;back if function aborted
	CP	82H		;skip to end (no more)
	JR	Z,forchk	;don't bother going through whole list
	CP	81H		;F1 = SYSOP KILL MESSAGE
	CALL	Z,sysdel	;delete if selected
	CALL	updmn		;update last msg# retrieved
noupd	CALL	repopt		;try new reply option
	CALL	cret
	JR	fseq		;and repeat now
;
forchk	LD	HL,dummy	;point to buffer holding kill numbers
	LD	(xadd),HL	;save them for killing
	XOR	A		;have to match exactly
	LD	(mflag),A	;for message numbers
	CALL	csmark		;check for kill mark, Z=no, NZ=yes
	JP	NZ,kilcnt	;go if we have some to kill
forkil	XOR	A		;then remove flag
	LD	(smark),A	;save it
	JP	allrd		;and continue with routines
;
sysdel	LD	(smark),A	;else set NZ flag to show msgs to kill
	CALL	bank3		;else reselect bank
	CALL	gma		;get message address
	LD	HL,(xadd)	;point to number storage
	DEC	HL		;step back one
	LD	A,(IX+5)	;get LSB number
	LD	(HL),A		;save it
	INC	HL		;point to next location
	LD	A,(IX+6)	;get MSB number
	LD	(HL),A		;save it
	INC	HL		;point to next
	LD	(HL),0		;then insert 0's to mark end
	INC	HL		;insert second set
	LD	(HL),0
	LD	(xadd),HL	;where to start nex time
	LD	HL,msg109	;inform we have deleted it
	CALL	out		;send it out
	XOR	A		;remove value in A
	RET			;and go back
;
allrd	LD	A,(trkflg)	;see if flag on
	OR	A		;Z=no, NZ=move to next board
	JP	Z,conmsg	;go if no tracking
	CALL	cv32		;check for carrier
allmlp	CALL	bank1		;else select user bank
	LD	A,(trkbrd)	;get board we are at
	INC	A		;add 1 to adv to next
allrd0	LD	B,A		;save it
	LD	A,(maxbrd)	;see if gone all the way
	CP	B		;B=present board, A=total
	JR	C,mlwrap	;check for past end of max
	LD	A,(orgbrd)	;see if back at original brd
	CP	B		;Z=all done, we were already here
	JP	Z,comp		;go if completed circle
	LD	A,B		;else get board number we want
	LD	(trkbrd),A	;save it
which	CALL	trkml		;and go try it
	JR	Z,allmlp	;loop if no mail in this board
	LD	A,C		;get board #
	CALL	selok		;switch boards to new one
where	JP	gtmail		;and try more mail
mlwrap	LD	A,1		;start with board 1 again
	LD	(trkbrd),A	;save it
	JR	allrd0		;and loop back fo more
;
gtmail	LD	HL,trkml	;routine to use for tracking mail
	LD	(which+1),HL	;save it for subroutine use
	LD	HL,gtmail	;where to resume in subroutine
	LD	(where+1),HL	;save it for resume from sub
	LD	HL,8000H	;start of messages in bank
	LD	A,(track)	;see if mail track on
	BIT	0,A		;check only 1 bit
	CALL	NZ,intrk	;see if mail tracking on
gtmlp	CALL	bank3		;select msg bank
	LD	(msgadd),HL	;save it for adding later
	LD	A,(HL)		;get a byte (check for end of mail)
	OR	A		;0=end of list
	JR	Z,allrd		;go if all done
	PUSH	HL		;else move to index for check
	POP	IY		;IY=message address now
	CALL	musub		;Z=match, NZ=no match in header
	JR	NZ,n4u		;skip if msg not your mail
	BIT	2,(IY+7)	;see if its been read yet.
	JR	NZ,n4u		;continue if yes
	CALL	dphead		;else show msg heading
	JP	C,retabt	;abort if ctrl C or A
	CP	'N'		;else next msg
	JR	Z,gtmlp1	;skip showing lines if yes
	CALL	shline		;show the message lines
	JP	C,retabt	;menu on A or CTRL C
	CALL	cv32		;check for carrier
	CALL	gmay		;get msg address
	SET	2,(IY+7)	;set bit for KILL at sign off routine
	BIT	1,(IY+7)	;see if PRIVATE or PUBLIC
	JR	NZ,pm		;if SET it was a PRIVATE msg (kills)
	LD	A,(track2)	;else see if PUBLIC MSG KILLS
	BIT	1,A		;Z=NO, NZ=YES KILL PUBLICS
	JR	NZ,pm		;NZ means it will be KILLed anyway
	LD	A,1		;else make sure its marked to save
	LD	(mkset),A	;else set for NZ value (so we save it)
pm	CALL	spclrt		;check for special commands (gtmlp0)
gtmlp1	CALL	cv32		;check for carrier
n4u	CALL	bank3		;reselect bank3 (msg section)
	LD	HL,(msgadd)	;get back message address
	PUSH	HL
	POP	IY		;used to get size of message
	CALL	muadd		;add HL,DE to get next location
	JR	gtmlp		;and loop back for next check
;
spclrt	CALL	cv45		;2 c/r's
	XOR	A		;0=use this routine
	LD	(repval),A	;save it
	LD	HL,msg98	;full message first
	LD	A,(autofl)	;test for auto kill invoked
	OR	A		;Z=no, NZ=yes
	JR	Z,spclr		;continue with full msg if off
	LD	HL,msg98a	;else bypass delete word
spclr	CALL	hot		;show it on video
	CP	'D'		;delete message?
	JR	Z,dodelm	;delete message if yes
	CP	'N'		;want next msg
	RET	Z		;back if yes
	CP	'Q'		;abort to the menu
	JR	Z,doquit	;quit if yes
	CP	'R'		;else want to reply?
	JP	Z,dorply	;go if yes
	CP	'S'		;skip msg
	JR	Z,noread	;go if wanted again later
	CALL	cd		;see if carrier still online
	RET	NZ		;back if gone
	JR	spclrt		;else loop back again
;
noread	RES	2,(IY+7)	;UNMARK MSG READ FLAG
	RET			;and go back
;
repopt	CALL	qtest		;see if in QUICK SUM mode
	RET	NZ		;back if yes, not allowed to reply
	CALL	bank1		;see if REPLY option enabled
	BIT	6,(IX+75)	;Z=no, NZ=yes
	JR	NZ,repop	;continue if on
	CALL	bank3		;else just continue
	RET			;and go back
repop	CALL	bank3		;else reslect msg bank
repo0	CALL	cv45		;2 cr's
	LD	A,1		;set for NZ
	LD	(repval),A	;save it (NZ value)
	LD	HL,msg98b	;R/N/Q
repo	CALL	hot		;show it
	CP	'Q'		;quit?
	JR	Z,doquit
	CP	'R'		;reply?
	JR	Z,dorply	;go if yes
	CP	'N'		;next?
	RET	Z		;back if yes
	CP	81H		;sysop delete (mark)
	JP	Z,sysdel	;mark it (USE RET IN SYSDEL)
	CALL	cd
	RET	NZ		;back if lost
	JR	repo0		;else loop
;
doquit	POP	AF		;remove return address
doabt	LD	A,(trkflg)	;see if in scan
	OR	A		;Z=no, NZ=yes
	JP	Z,msgmen	;back if not
	LD	A,(track)	;see if abort, returns or stops here
	BIT	2,A		;Z=stops here, NZ=returns to original
	JR	Z,comp0		;stop if desired
comp	LD	A,(orgbrd)	;else get original board
	LD	B,A		;see if we are still on same brd
	LD	A,(board)	;if same don't bother re-loading
	CP	B		;Z=same board
	JR	Z,comp0		;skip if not required
	LD	C,B		;else get number to reload
	CALL	selok		;change back to it
comp0	XOR	A		;remove flag
	LD	(trkflg),A	;save it
	JP	msgmen		;and back to menu
;
dodelm	CALL	setspl		;go set special flag
	LD	HL,(msgadd)	;get current address for msg
	LD	(val6),HL	;save this address for ret
	CALL	killit		;and remove this message
	CALL	resspl		;reset flag byte
	LD	HL,(val6)	;get address we were at
	POP	AF		;remove return address
	JP	gtmlp		;and try this message for a match
;
dorply	LD	HL,(usrnum)	;get this callers number
	LD	DE,(kilsub)	;see if msg was TO them
	OR	A		;do with a SBC
	SBC	HL,DE		;do it
	JR	NZ,not2u	;skip if not
	CALL	gmay		;else msg address to IY
	SET	2,(IY+7)	;show that he read it
not2u	CALL	gma		;msg ADDRESS to IX
	LD	(val7),IX	;save current msg address
	CALL	rdix56		;HL to get MSG# we are at
	LD	(val6),HL	;save it for resume
	CALL	msgroom		;see if room first
	JR	Z,dorly		;continue if room
	CALL	mbif		;sorry buffer is full
	LD	A,(repval)	;see where to return
	OR	A		;Z=SPCLRT, NZ=REPOPT
	JP	Z,spclrt	;and back to short prompt
	JP	repopt		;else use second routine
dorly	LD	A,1		;set NZ flag
	CALL	setspl		;else set flags
	CALL	leave0		;and enter the leave msg routine
	CALL	resspl		;turn off flag options
	LD	(mflag),A	;insert for exact match
	LD	HL,(val6)	;get last MSG# you replied to
	LD	(val2),HL	;and go look for where we left off
	CALL	fndnum		;and find it (MSGADD=THIS ADDRESS)
	RET			;and go back Z=fnd, NZ=not found
;
intrk	LD	A,(maxbrd)	;get total active systems
	CP	1		;if 1, then skip this option
	RET	Z		;back if off
	LD	A,(trkflg)	;see if currently in loop
	OR	A		;Z=no, NZ=yes don't save
	RET	NZ		;back if in option now
	LD	A,(board)	;get current board
	LD	(trkbrd),A	;save it
	LD	(orgbrd),A	;save starting point too
	LD	(trkflg),A	;set flag NZ
	RET			;else go back, saved all info
;
trknew	CALL	brdchk1		;see if allowed on A=BRD #
	RET	Z		;Z=no, NZ=yes, if no, then return
	CALL	bank1		;select users bank
	PUSH	IX
	POP	HL		;move to HL for add
	LD	DE,41		;offset to mail address
	ADD	HL,DE		;point to it
	LD	A,(trkbrd)	;get board we want to checkout
	CALL	addsu0		;retrieve an offset (mail flag)
	PUSH	HL
	POP	IX		;IX=your last msg number
	LD	HL,sys		;find list in boards
	LD	A,(trkbrd)	;get board we want
	CP	1		;see if board 1
	JR	Z,brd1		;go if first one
	DEC	A		;else minus 1 for stepping
	LD	B,A		;save it
	LD	DE,16		;offset between all info
systp	ADD	HL,DE		;step HL to where it has to go
	DJNZ	systp		;loop til done
brd1	PUSH	HL		;move to IY for board info
	POP	IY		;IY=info for each board
	CALL	rdix01		;last LSB/MSB you read
	LD	E,(IY+6)	;get end msg number in board
	LD	D,(IY+7)	;get MSB of ending msg number
	OR	A		;clear carry flag
	SBC	HL,DE		;HL-DE
	JR	C,somenu	;if DE>HL then you get a carry/borrow
	CP	A		;else there is none, set Z flag
	RET			;and go back
somenu	LD	A,(trkbrd)	;get board we want
	LD	C,A		;move for return to load board
	LD	A,0
	OR	1		;set NZ flag
	RET			;go back and continue now
;
mnum	LD	DE,msgnb	;point to buffer to use
mnum0	JP	bindec		;convert to ASCII (use RET in sub)
nbta	LD	DE,numbuf	;numbuf to ASCII
	JR	mnum0		;and continue
;
mbif	LD	HL,err7		;show we got no room left
	CALL	out		;display it
	RET			;and back
;
msgroom	CALL	ckroom		;see if room for more
	RET	Z		;back if yes
makerm	LD	HL,(usrnum)	;else we try to delete msgs to ALL
	PUSH	HL		;save for later
	LD	A,1		;enable mail check
	LD	(mcf),A		;save it
	LD	HL,0FFFFH	;number of ALL
	LD	(usrnum),HL	;save it
	CALL	fndnam		;we look for than number NOW
	CALL	mcfoff		;save AF, reset mail check, ret
	POP	DE		;HL=MSGADD where match is
	LD	(usrnum),DE	;but first we restore your number
	JR	Z,fmall		;go if we found a msg to ALL
samadd	OR	1		;else set a NZ flag
	LD	A,0		;and return to caller
	RET			;for more processing
fmall	PUSH	HL		;save MSGADD pointer
	LD	DE,(val7)	;get current msg address
	OR	A		;clear carry
	SBC	HL,DE		;see if SAME address
	POP	HL		;get back in case its not
	JR	Z,samadd	;forget it if same address
	LD	(msgadd),HL	;point to where we can delete a msg
	CALL	mkill		;remove it from the list (msgadd)
	JR	msgroom		;check and repeat
;
