;Second part of message entry module
;MUST appear in listing after MSGENT/ASM op code
;Filename : MSGENT1/ASM
;
resspl	XOR	A		;remove the flag
setspl	LD	(msgflg),A	;save result
	RET			;and return Z, NZ
;
retabt	LD	HL,abtmsg	;option aborted msg
	CALL	out		;send it out
	JP	doabt		;if abort try reload or stop here
;
smn	LD	HL,msg47	;Msgs
	CALL	out
	LD	HL,msg39	;FRM :
	CALL	out
	CALL	gba		;get board address
	CALL	rdix45		;read lowest msg number
	CALL	mnum		;DE to buffer, CONVERT to ASCII
	LD	HL,msgnb
	CALL	out
	CALL	cv39a		;TO:
	CALL	rdix67		;read highest msg#
	LD	DE,clnum
	CALL	bindec		;CONVERT to ASCII
	LD	HL,clnum	;what to display
	CALL	out		;show it
	CALL	cret		;c/r
	RET			;go back
;
shline	LD	A,(qflag)	;see if in summary mode
	OR	A		;check for status
	RET	NZ		;back if in that mode
	CALL	cv45		;2 c/r's
	CALL	cv53		;select msgs, get usr# and check
	JR	NZ,shdiff	;go if different
	LD	A,(usrnum+1)	;else get MSB
	CP	(IY+9)		;check it
	JR	NZ,shdiff	;continue if you are not TO
	LD	A,(mrdflg)	;see if this is ok to mark
	OR	A		;Z=skip it, only in MAIL only
	JR	Z,shdiff	;check results, skip if Z
	SET	2,(IY+7)	;else mark as read, can autokill
shdiff	PUSH	IY		;move address to HL
	POP	HL		;saves loading it
	LD	DE,12		;offset to variable length SUB
	ADD	HL,DE		;point to it
	LD	B,25		;maximum length for SUB
ftext	LD	A,(HL)		;get a byte
	CP	0FFH		;to ALL?
	JR	Z,shl0		;continue, we found start
	CP	13		;else a C/R
	JR	Z,shl0		;continue we found start
	INC	HL		;else point to next
	DJNZ	ftext		;loop for 25 characters
	DEC	HL		;back up for next INC
shl0	INC	HL		;point to start of text
	LD	(val1),HL	;save it for now
	LD	A,(msglin)	;get total lines allowed
	LD	(val2),A	;save it for loop
shmlp	LD	HL,(val1)	;get start of text
shmlp0	LD	A,(HL)		;get byte
	CP	0FFH		;end of msg
	RET	Z		;back if all shown
	LD	A,(linel)	;else get line length
	LD	B,A		;move to loop
dislin	CALL	hotlin		;show to C/R or B length
	RET	C		;back if ABORTed
	CP	81H		;see if SYSOP KILL mode enabled
	RET	Z		;back if yes
	CP	82H		;stop this routine
	RET	Z		;back if yes
	CP	'N'		;skip to next?
	RET	Z		;back if yes
	CP	13		;look for c/r
	JR	Z,nxline	;skip putting one in ourselves if yes
	CALL	cret		;c/r
	DEC	HL		;back cause of c/r ret from hotlin
nxline	INC	HL		;point to start of next line
	LD	A,(val2)	;get total line counter
	DEC	A		;0=all done
	RET	Z		;back if all done
	LD	(val2),A	;else save it
	JR	shmlp0		;loop til all shown
;
gtnum	LD	HL,msg35	;Remove Msg # :
gtnum0	CALL	out		;send it
	LD	HL,buff1	;use input buffer
	LD	A,5		;allow 5 digit number
	CALL	uinput		;get input
	LD	HL,buff1	;convert buffer to number
	CALL	decbin		;convert to binary
part3	LD	(val2),BC	;save value
	LD	A,B		;check for 0
	OR	C		;its invalid
	JR	Z,nonum		;back if invalid number
setzf	CP	A		;else set Z flag
	RET			;and return
nonum	OR	1		;set NZ flag
	LD	A,0
	RET			;and go back
;
ckpro	CALL	chksys		;see if master online
	JR	NZ,setzf	;Z=ok to process
	CALL	cv53		;select bank, get number and check
	JR	NZ,not2		;skip if LSB don't match
	LD	A,(usrnum+1)	;get MSB to match
	CP	(IY+9)		;check MSB
	RET	Z		;back if your are TO:
not2	LD	A,(usrnum)	;get LSB again
	CP	(IY+10)		;see if you are FM :
	JR	NZ,notfrm	;go if not from either
	LD	A,(usrnum+1)	;check MSB
	CP	(IY+11)		;if not frm, then we have more
	RET	Z		;back if you are FROM :
notfrm	BIT	1,(IY+7)	;see if private msg frist
	JR	Z,notpri	;go if not private
	CALL	chksys		;see if master sysop/online
	JR	NZ,setzf	;master sysop OK
	LD	C,8		;bit to check
	CALL	chkre0		;check for remote sysop access
	JR	NZ,setzf	;remote SYSOP ok to process
	LD	HL,msg37	;else PRIVATE msg
	JP	nonum		;and go handle it
notpri	CALL	bank3		;reselect bank 3 first
	BIT	0,(IY+7)	;check for sysop protected
	RET	Z		;back if allowed to process
	JP	setzf		;set Z flag and return (check in KILL)
;
updmn	CALL	bank3		;reselect msg bank
	CALL	gmay		;get message address
	LD	C,(IY+5)	;get LSB number
	LD	B,(IY+6)	;get MSB number
	PUSH	BC		;save for bank select
	CALL	bank1		;point to users data (IX)
	POP	BC		;then get it back
	PUSH	IX		;move address to HL for offset
	POP	HL		;hl points to user data
	LD	DE,41		;offset to last ret numbers
	ADD	HL,DE		;find it
	LD	A,(board)	;get board they are on
	CALL	addsu0		;retrieve offset from table
	LD	(HL),C		;save LSB number
	INC	HL		;point to next
	LD	(HL),B		;save MSB number
	CALL	bank3		;back to MSG bank
	RET			;and go back
;
dskoff	LD	A,(mask)	;get mask
	RES	5,A		;turn off value
dskof0	LD	(mask),A	;save it
dskof1	OR	A		;Z=options off, NZ=1 still active
	RET			;and go back
prtoff	LD	A,(mask)	;get mask
	RES	4,A		;turn off option
	JR	dskof0		;and continue
chkopt	LD	A,(mask)	;get printer/disk bits
	JR	dskof1		;set flags and return
;
dorule	CALL	tabed		;tab in
	LD	A,(linel)	;get line length max of msg
	LD	B,A		;move to loop for ruler
	DEC	B		;minus 2 for !---! stop characters
	DEC	B		;then use it as value
	LD	A,'!'		;do start first
	CALL	output		;do it
prule0	LD	A,'-'		;then all the ----
	CALL	output		;to the screen
	DJNZ	prule0		;loop til done that job
	LD	A,'!'		;then a last ! to end it
	CALL	output		;and ready to start with input
	RET			;and back to caller
;
tabed	LD	B,4		;ruler starts 4 spaces in
prule	LD	A,' '		;so send out a few
	CALL	output		;do it 5 times
	DJNZ	prule		;loop til done
	RET			;and back
