	PAGE
;File Routines
;Copyright 1988 by Mel Patrick
;Filename - UPDOWN/ASM
;
dodo	CALL	bank1		;select users bank
	CALL	b7ix73		;test for remote sysop
	JR	NZ,dodo0	;continue if allowed
	CALL	b7ix75		;check for master sysop
	JR	NZ,dodo0	;continue if he is online
	CALL	b2ix74		;check for special download access
	JR	NZ,dodo0	;continue if he has it
	CALL	b1ix74		;else see if allowed in download at all
	JR	NZ,dodo0	;continue if he is
	JP	doupn		;else he's not got enough access
;
dodo0	CALL	cv55		;get filename from user
	CALL	cv32		;check carrier
	CALL	cv18		;check length input
	JP	Z,dofile	;back if nothing found
	CALL	dsrch		;see if matching filename
	JR	Z,dodo1		;continue if matching filename
	LD	HL,msg62	;FILENAME DOES NOT EXSIST
	CALL	out		;show it
	JR	dodo0		;and repeat the prompt
dodo1	DEC	HL		;only need 1 back down
	LD	(val1),HL	;save the pointer to the filespec
	LD	A,(mask)	;see if he selected REMOVE
	CP	1		;see if REMOVE enabled
	JP	NZ,dodoa	;Z=removing, NZ=DOWNLOAD/MOD ACC
	LD	HL,msg85	;else REMOVE THIS FILL
	CALL	cv12		;look for Y
	JP	NZ,dofile	;abort back to menu
	CALL	chksys		;see if master online
	JR	NZ,dodo1a	;continue if yes
	CALL	b7ix73		;see if remote sysop online
	JR	NZ,wgr		;go if remote online
	CALL	cv56		;select bank, pointer to IX
	LD	E,(IX+18)	;get LSB FROM
	LD	D,(IX+19)	;get MSB FROM
	LD	HL,(usrnum)	;see if from YOU?
	OR	A		;clear carry
	SBC	HL,DE		;test it
	JR	Z,fromu		;go if from you
	LD	HL,err5		;else SORRY msg
	JP	revm2		;else print it and back to menu
fromu	LD	A,(track1)	;see if allowed to remove from both
	BIT	4,A		;Z=from menu only, NZ=from BOTH
	JR	Z,nftk		;go if menu remove only
	JR	dodo1a		;else allow BOTH
wgr	LD	C,4		;bit to check (BIT 2)
	CALL	chkre0		;see if he is allowed to remove it
	JR	Z,nftk		;go if only to remove from menu
dodo1a	LD	HL,msg100	;remove file from disk?
	CALL	cv12		;look for a Y
	JR	NZ,nftk		;skip removal from disk if N
singdl	CALL	bank2		;else point to name
	CALL	mvthfl		;move the file for OPEN
	LD	A,13		;insert a c/r
	LD	(DE),A		;in file line
	CALL	dodot		;change . to / for working on disk
	CALL	pst0		;and open the file
	JR	NZ,nftk		;go if no file of that kind
	CALL	rmvfil		;and remove the file
nftk	CALL	bank2		;select download bank
	LD	HL,0FF80H	;last possible entry in list
	LD	DE,(val1)	;get address to empty
	OR	A		;clear carry
	SBC	HL,DE		;if Z, then only remove this one
	JR	Z,revm1		;go if only to empty last entry
	LD	HL,(val1)	;entry add
	LD	DE,80		;offset to next slot
	ADD	HL,DE		;point HL to next slot
	PUSH	HL		;move to DE for sub
	POP	DE		;DE=address of next slot
	LD	HL,0FFD0H	;top of list
	OR	A		;clear carry
	SBC	HL,DE		;find size to move
	PUSH	HL		;answer was in HL, need in BC
	POP	BC		;BC=size to move now
	LD	HL,(val1)	;get back starting position
	PUSH	HL		;save til after calc
	LD	DE,80		;offset to next address
	ADD	HL,DE		;HL=next address again
	POP	DE		;de=first address (destination)
	LDIR			;and move all the stuff down 1
revm1	LD	HL,0FF80H	;ALWAYS erase last entry
	LD	BC,7FH		;last entry slot and empty area
	CALL	erase		;do it
	CALL	countd		;update download totals
	CALL	calbrd		;and show on the video
	LD	A,1		;show we modified the file (SAVE)
	LD	(upflag),A	;save it in case of MDF
	LD	HL,msg86	;then print the news
revm2	CALL	out		;do it
	JP	dofile		;and back to menu
dodoa	CALL	val1ix		;get address pointer (IX)
	BIT	4,(IX+2)	;check for good file 0=YES NZ=no!
	JP	NZ,flerr1	;if bad file, give bad news
	LD	A,(mask)	;see if MOD ACC in effect (2)
	CP	2		;Z=YES MOD ACC, NZ=no skip spcl routine
	JP	Z,modfil	;go if modify file access in effect
	BIT	3,(IX+2)	;0=ASCII type NZ=XMODEM required
	JR	NZ,dodo3	;skip offer if Xmodem only
dodo2	CALL	upper		;else offer ASCII or XMODEM
	CALL	ckol		;Z=remote, NZ=local keyboard
	JP	NZ,dofile	;skip if local op
	LD	HL,menu7
	CALL	cv12		;look for Y or others
	JR	Z,doxo		;go if yes (ymodem)
	CP	'X'		;want XMODEM?
	JP	Z,doxo		;go if XMODEM wanted
	CP	'A'		;else want ASCII output?
	JP	Z,ascout	;go if ASCII output wanted
	CP	'E'		;else want to EXIT?
	JP	Z,dofile	;go if yes
	CALL	cv32		;check carrier
	JR	dodo2		;else repeat menu for twit
dodo3	LD	HL,menu8	;Allow Xmodem, YMODEM, EXIT
	CALL	hot		;allow selection
	CP	'E'		;exit?
	JP	Z,dofile	;exit if yes
doxo	CP	'Y'		;see if YMODEM
	JP	Z,doyout	;go if yes
	JP	doxout		;else its XMODEM
;
doup	CALL	bank1		;select users back
	CALL	b7ix73		;check for remote sysop
	JR	NZ,doup0	;continue if remote feller
	CALL	b7ix75		;check for master sysop
	JR	NZ,doup0	;continue if master on system
	BIT	0,(IX+74)	;else regular check his access level
	JR	NZ,doup0	;continue if access allowed
doupn	LD	HL,err6		;sorry not enough level
	CALL	hot		;send it out
	JP	dofile		;and back to file menu
;
doup0	CALL	bank2		;select download bank of names
	LD	BC,(maxdwn)	;get total downloads allowed
	LD	HL,8000H	;starting point
ckfre	LD	A,(HL)		;get a byte
	OR	A		;0=nothing at this point
	JR	NZ,slot		;NZ=used for boards 1-8
	INC	HL		;else point to boards 9-16
	LD	A,(HL)		;get the byte
	DEC	HL		;back up in case its empty
	OR	A		;Z at this point means empty slot
	JR	Z,gtrm		;go if room for the entry
slot	LD	DE,80		;else offset to next
	CALL	addsub		;add hl,de dec bc
	JR	NZ,ckfre	;loop for maximum length
	LD	HL,msg54	;Sorry MENU IS FULL
	CALL	hot		;show it
	JP	dofile		;and back to menu
gtrm	LD	(val1),HL	;save point to insert file data
	LD	BC,79		;and erase anything there
	CALL	erase		;do it
modfil	LD	DE,1		;cancel offsets
	LD	(off1),DE
	DEC	DE		;offset to second one by 1
	LD	(off2),DE
	CALL	gtupdr		;get upload drive for the board we're in
	SUB	'0'		;make it binary 0-7
	LD	B,A		;move for reading in dir free space
	LD	C,0FFH		;read in 4 bytes only
	LD	HL,dummy	;point to buffer
	LD	A,@ramdir	;read it in
	RST	svc
	JR	NZ,gtderr	;go if error during this
	LD	HL,(dummy+2)	;read in LSB/MSB in K free space
	LD	DE,ufree	;where to convert it
	CALL	bindec		;convert binary to DECIMAL
	LD	HL,msg120	;then display it
	CALL	out		;so they/we can see it
gtderr	CALL	tstmdf		;see if using multi DL files
	JR	NZ,udefa	;only allowed on one board
	CALL	bank1		;see if SYSOP here or REG user
	CALL	b7ix73		;check for remote sysop
	JR	NZ,gtrm0	;go if remote sysop
	CALL	b7ix75		;check for MASTER sysop
	JR	Z,udefa		;go if regular user
gtrm0	CALL	bank2		;select last bank
	LD	HL,msg55	;BOARDS AVAIL
	CALL	out		;show title
	CALL	shbrds		;and print the names
gtrm1	CALL	val1ix		;get address of board data
	CALL	rdix01		;get LSB boards/MSB board bit
	LD	A,H
	OR	L		;test for any so far
	JR	Z,gtrm2		;skip next section if none
	CALL	cret		;c/r
	LD	HL,msg106	;FILE AVAIL ON :
	CALL	out		;send it
	PUSH	IX		;save pointer
	PUSH	IX		;move to HL for calc
	POP	HL
	LD	DE,37		;do a subtract
	OR	A
	SBC	HL,DE		;HL=37 bytes lower
	PUSH	HL		;now
	POP	IX		;IX now points 38 bytes lower
	CALL	brdac		;and display the board letters allowed
	POP	IX		;then restore to proper location
gtrm2	LD	HL,msg20	;WHICH ONE?
	CALL	hot		;and show it
	CP	'?'		;want a list of boards?
	JR	Z,gtrm0		;repeat list if yes
	CP	13		;look for default board only
	JR	Z,udefb		;go if only this one used
	SUB	40H		;else make it digit 1-16
	LD	B,A		;move to B for checking
	LD	HL,(val1)	;get address to use for download data
	LD	A,(maxbrd)	;get total boards allowed
	CP	B		;check against B
	JR	C,bor		;default if out of range
	CALL	setbit		;else use routine in SYSEDIT to set it
	JR	gtrm1		;and repeat til <ENTER> pressed
bor	LD	HL,msg69	;BOARD SELECTION OUT OF RANGE
	CALL	out		;show it
	JR	gtrm0		;and try again
udefa	CALL	bank2		;reselect the download bank
	LD	A,(board)	;get current board we are in
	LD	B,A		;move to loop
	LD	HL,(val1)	;always set file for same board
	CALL	setbit		;do it
udefb	CALL	cv59		;check cd,if lost erase DL
	CALL	cv56		;select bank, IX to pointer
	CALL	rdix01		;check board bits in HL (ix)
	LD	A,H
	OR	L		;if none active SYSOP screwed up
	JP	Z,gtrm0		;so ask him for more board
	LD	A,(mask)	;see if in file access mod rout
	CP	2		;Z=yes, NZ=no
	JR	Z,domod		;skip if modify routine
notmod	CALL	ckol		;Z=remote, NZ=keyboard local
	JR	NZ,n4s		;don't bother if local
	LD	HL,msg56	;File for SYSOP only?
	CALL	cv12		;look for Y
	JR	NZ,n4s		;go if not for sysop
	CALL	val1ix		;get file address
	SET	0,(IX+2)	;set for SYSOP only, erase after xfer
n4s	CALL	cv59		;check cd, erase dl?
	CALL	val1ix		;check for sysop only
	BIT	0,(IX+2)	;Z=normal NZ=sysop only
	JR	NZ,r4s		;bypass question if sysop file only
domod	CALL	val1ix		;point to file attributes
	LD	HL,msg57	;<V>isible or <I>nvisible file
	CALL	hot		;select
	CP	'I'		;if invisble, then for special users
	JR	NZ,r4s		;go if regular file for all
	CALL	val1ix		;get data address to use
	SET	1,(IX+2)	;turn on invisible status
	JR	r4s0		;skip RES line
r4s	RES	1,(IX+2)	;make it VISIBLE
r4s0	CALL	cv59		;check cd, erase file?
	CALL	bank1		;reselect users bank
	CALL	b7ix75		;check for master sysop
	JR	Z,nomas		;skip next section if not master
	CALL	cv56		;select bank, pointer to IX
	LD	HL,msg57a	;SINGLE DOWNLOAD?
	CALL	cv12		;look for Y
	JR	NZ,domo		;skip if not
	CALL	val1ix		;else get back ptr to attributes
	SET	6,(IX+2)	;turn option on
	JR	domo0		;and skip reset
domo	CALL	val1ix		;reselect attributes
	RES	6,(IX+2)	;else turn it off
domo0	LD	HL,msg31	;else ask if he was it protected
	CALL	cv12		;look for Y
	JR	NZ,nomass	;skip if not
	SET	5,(IX+2)	;file is there, but not shown
	JR	nomas		;skip to next section
nomass	RES	5,(IX+2)	;else turn off protection
nomas	CALL	bank2		;reselect file bank for filename
	LD	A,(mask)	;see if modify in effect
	CP	2		;Z=yes, NZ=no
	JP	Z,redes		;go get new description if yes
nomas0	CALL	cv59		;check cd, erase if gone
	CALL	wrpoff		;turn off word wrap
	CALL	cv55		;get filename from user
	CALL	cv59		;check cd, erase if gone
	CALL	bank2		;reselect the bank
	CALL	cv18		;get length of input
	JP	Z,erabrt	;erase anything and then this menu
	CALL	dsrch		;and see if matching filename
	JR	NZ,nodup	;go if not a name already
	LD	HL,err13	;else sorry DUPLICATE filename
	CALL	out		;show it
	JP	erabrt		;and abort the process (erase entry)
nodup	LD	DE,(val1)	;point to where to store filename
	PUSH	DE		;save pointer
	INC	DE
	INC	DE
	INC	DE		;in memory
	PUSH	DE		;use for pointing at filename
	CALL	mvfl1		;copy bytes to memory
	POP	HL		;point HL to start ASCII filename
	POP	IX		;set an end marker (point to entry)
	LD	(IX+15),13	;set a c/r in line
	CALL	crfcb		;create a file control block
	JR	Z,flok		;continue if filespec OK!
	LD	HL,msg61	;else INVALID FILESPEC
	CALL	out		;send it out
	JP	r4s		;and repeat prompt
flok	CALL	ckol		;Z=remote, NZ=local keyboard
	JR	Z,redes		;get description if remote
	CALL	dojim		;insert for SYSOP in case of .
	CALL	flopen		;and OPEN the file
	JR	Z,flok0		;go if the file was there somewhere
	LD	HL,msg62	;FILE NOT ON DRIVES
	CALL	out
	JP	erdow		;erase and forget anything else
flok0	CALL	getk		;get data from FCB
	CALL	insrtk		;and insert size in K into file data
redes	CALL	bank2		;reselect bank
	LD	HL,msg59	;DESCRIPTION msg only
	CALL	out		;send it out
	LD	HL,buff2	;address to get input
	LD	A,55		;get comments
	CALL	linput		;allow upper/lower case entry
	CALL	cv59		;check carrier, erase if gone
	CALL	bank2		;reselect bank after CD
	CALL	cv18		;see if anything input
	JR	NZ,redes0	;continue if we got a description
	LD	A,(mask)	;else see if in modify mode
	CP	2		;Z=yes, NZ=no
	JR	NZ,redes	;force a description if not
	JR	abtdes		;else leave current description alone
redes0	LD	HL,(val1)
	LD	DE,24
	ADD	HL,DE
	EX	DE,HL
	LD	HL,buff2
	LD	BC,56
	LDIR			;block moves info
	LD	HL,(val1)	;get file address
	LD	DE,15		;offset to DATE
	ADD	HL,DE
	CALL	cv26		;point to year and move data
	LD	A,(mask)	;see if modify in effect
	CP	2		;Z=yes, NZ=no
	JR	NZ,newdes	;go get new description if NO
abtdes	LD	(upflag),A	;save it again
	LD	HL,msg110	;else indicate file was modified
	CALL	hot		;show it
	JP	dofile		;and back to menu
newdes	LD	HL,(usrnum)	;get this users number
	CALL	val1ix		;get data pointer
	LD	(IX+18),L	;insert in file data line
	LD	(IX+19),H
resel	CALL	bank2		;reselect download bank
	CALL	upper		;upper case inputs
	LD	HL,menu7	;PROTOCOL TO USE
	CALL	cv12		;look for Y or others
	JP	Z,doxup		;go if yes
	CP	'X'		;XMODEM type
	JP	Z,doxup		;go if yes
	CP	'A'		;else ASCII type
	JP	Z,doascup	;go if yes
	CP	'E'		;else exit?
	JP	Z,erabrt	;else abort and back to menu
	CALL	cv59		;check cd, erase if gone
	JR	resel		;else reprint selections
;
eradow	CALL	clrent		;remove upload entry from file
	LD	HL,ctrl		;and set xlate table on
	RES	2,(HL)		;for restarting
	JP	hbort		;and then leave the system
;
erdow	CALL	clrent		;remove this entry from menu
erdowl	CALL	clrtyp		;clear type ahead buffer
	CALL	ctrlx		;send control x
	CALL	delay2		;wait 2 seconds
	CALL	rdbyte		;see if any more in the buffer
	JR	Z,erdowl	;loop and send another ctrlX if yes
	LD	HL,err11	;file error
erdow0	CALL	out
	JP	dofile		;and back to menu
;
erabrt	CALL	nfg		;erase the entry
	LD	HL,abtmsg	;aborted!
	JR	erdow0		;and print and exit
;
doascup	CALL	credits		;see if credit for time
	CALL	ckol		;Z=remote, NZ=local keyboard
	JP	NZ,sucess	;exit with message if successful
	CALL	cv60		;does checking of upload
	LD	HL,msg102	;then how to quit it
	CALL	out		;show it too
	LD	HL,ctrl		;turn off XLATE table
	SET	2,(HL)		;for looking for control value
rafout	LD	HL,buffer	;point to 1280 byte buffer
	LD	(xadd),HL	;save pointer
	LD	HL,1280		;maximum bytes to read
	LD	(rec),HL	;save counter to use
raflp	CALL	cd		;check for carrier
	JP	NZ,erafil	;erase if lost
	CALL	rdbyte		;read byte from rs232
	JR	Z,raflp0	;skip keyboard if char recd
	CALL	kbd		;scan the keyboard
	JR	NZ,raflp	;loop if nothing
raflp0	CP	3		;CTRL C (end of xfer)
	JP	Z,w7done	;go if yes
	CP	24		;else CTRL X for all done
	JP	Z,w7done
	CP	4		;else CTRL D (EOT)
	JP	Z,w7done	;go if yes
	CP	10		;purge all LF's
	JR	Z,omitlf	;so we don't need worry about them
	AND	7fh		;mask out the high bit
	LD	HL,(xadd)	;get address to store byte at
	LD	(HL),A		;store it
omitlf	LD	C,A		;move for display
	PUSH	BC		;save character
	CALL	vido		;send to video unless control code
	POP	BC		;get back character now
	LD	A,(sysopt+1)	;test for echo back
	AND	64		;Z=no, NZ=yes echo
	JR	Z,skpech	;skip echo if off
	LD	A,C		;else get back character
	CP	13		;c/r
	JR	Z,echo		;go if ok
	CP	10		;LINE FEED
	JR	Z,echo		;send if yes
	CP	8		;backspace?
	JR	Z,echo
	CP	' '		;check for other controls
	JR	C,skpech	;skip echo if control code
echo	CALL	sbyte		;send back the character
	CALL	slower		;slow it down somewhat
skpech	LD	A,C		;get back char
	CP	10		;purge all LF's
	JR	Z,raflp		;back if we got one
	INC	HL		;point to next
	LD	(xadd),HL	;save for next time
	LD	HL,(rec)	;get counter
	DEC	HL
	LD	(rec),HL	;save count
	LD	A,H
	OR	L		;if 0, then block is full, write
	JR	NZ,raflp	;and loop back for more
	LD	A,13H		;else send a pause
	CALL	sbyte		;to remote so we can save data
	CALL	delay1		;wait for line to clear
	LD	BC,1280		;bytes to write out
	CALL	wrsub		;write block to disk
	LD	A,11H		;ctrl q to start again
	CALL	sbyte
	JP	rafout		;and back to get even more
;
w7done	LD	HL,(xadd)	;get address of current data
	LD	DE,buffer	;point to buffer
	OR	A
	SBC	HL,DE		;find the length
	PUSH	HL
	POP	BC		;move to BC
	LD	A,B
	OR	C
	JR	Z,rafex		;just close if nothing
	CALL	wrsub		;write BC amount to DISK
	CALL	getk		;get fcb info before closing
	LD	A,1		;show we got a file
	LD	(upflag),A	;save it
rafex	JP	cv62		;close and sucess
;
ascout	CALL	ckol		;Z=remote, NZ=local keyboard
	JP	NZ,dofile	;skip if sysop here
	CALL	dodot		;change any . to / for opening
	CALL	pst		;open the file ONLY
	JP	NZ,flerr	;go on a file error
asc0	LD	HL,msg71	;<A>uto xfer, <M>anual xfer
	CALL	hot		;show it
	CP	'A'		;see if auto wanted
	JR	Z,doauto	;go if yes
	CP	'M'		;else manual?
	JR	NZ,asc0		;repeat if not correct answer
	LD	HL,msg72	;use <CR> for prompts
	CALL	out		;send it out
manw	CALL	inkey		;wait for CR
	CP	13
	JR	NZ,manw		;continue to wait
	JR	stflx		;and start when you get a c/r
doauto	CALL	cret		;do a carriage return first
	LD	A,18		;open buffer value
	CALL	sbyte		;send it
stflx	LD	(msgadd),A	;save byte to check later
saflp	CALL	fget		;read in a byte DE=FBUFF
	JR	Z,saflp0	;no read errors go!
	CP	1CH		;else read past eof?
	JR	Z,fltok		;go if all done
	JP	flerr1		;else we have an error,so abort
saflp0	CALL	sbyte		;send to remote
	CALL	slower		;settle it down
	CP	13		;allow c/r
	JR	NZ,notacr	;go if not a c/r
	CALL	vido		;send C/R to video display
	LD	A,(online)	;test to see if he needs a LF now
	BIT	3,A		;Z=no, NZ=YES!
	JR	Z,vlow		;continue if not a LF needed
	LD	A,10		;else send out a LF too
	CALL	sbyte		;send to remote
notacr	CP	8		;and backspace
	JR	Z,alcr
	CP	' '		;else don't display anything less
	JR	C,vlow		;skip if less than space
alcr	CALL	vido		;send to video display
vlow	CALL	scan		;check for ctrl S/Q (keyboard/remote)
	JR	NZ,saflp	;loop if no characters received
	CP	'P'		;else ctrl S (for pause)
	JR	Z,scode		;go if pause
	CP	'A'		;CTRL C (abort)
	JP	Z,dofile	;exit if yes
	CALL	cv32		;check for carrier
	JR	saflp		;else loop back for more
scode	CALL	cv32		;check for carrier
	CALL	inkey		;wait for a key
	CP	'Q'		;Xon again?
	JR	Z,saflp		;start sending if yes
	CP	'A'		;else ABORT (CTRL C)
	JP	Z,dofile	;back to menu if yes
	CP	13		;allow a c/r too
	JR	Z,saflp		;back if yes
	JR	scode		;else loop for control
fltok	LD	A,(msgadd)	;check for manual or auto
	CP	13		;MANUAL mode?
	JR	Z,fltmn		;go if yes
	LD	A,20		;else its AUTO mode
	CALL	sbyte		;close their buffer
fltok0	LD	(upflag),A	;show we had a DOWNLOAD
	JP	upfile		;and get out
fltmn	CALL	inkey		;wait for a c/r
	CP	13		;if nothing, then keep looping
	JR	Z,fltok0	;continue if received
	CALL	cd		;check for carrier
	JR	NZ,fltok0	;continue if carrier gone
	JR	fltmn		;else keep waiting
;
slower	LD	B,100
slowdn	DJNZ	slowdn		;slow down a little
	RET			;and then go back
;
